﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals

	' Layout editlist	
	Private btnDelete As Button
	Private svw1 As ScrollView	
	
	' Layout editlistdetails
	Private btnDbgSave As Button
	Private chkDelSrcWhenPicked As CheckBox
	Private chkHighlightCnt As CheckBox
	Private chkMasterImm As CheckBox
	Private chkMasterKbd As CheckBox
	Private chkUseMaster As CheckBox
	Private lblColour As Label
	Private lblListNo As Label
	Private lblMasterFile As Label
	Private lblMasterImm As Label
	Private lblMasterKbd As Label
	Private pnlColorPicker As Panel
	Private spnListNames As Spinner
	Private txtColourNo As EditText
	Private txtLongName As EditText
	Private txtMasterFile As EditText
	Private txtShortName As EditText
	Private chkAutoSelSngResFrmVcAdd As CheckBox
	Private chkHidePkdWhnRbldMultiLst As CheckBox
	
	' Not related to a layout
	Private mblnCancel As Boolean
	Private const DEBUGGING As Boolean = False
	Private cvsColorPicker As Canvas

End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	LoadData
	
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	
	If KeyCode = KeyCodes.KEYCODE_BACK Then
		If DismissPanels Then
			Return True
		End If
	End If
	Return False
	
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

	If UserClosed And Not(mblnCancel) And Not(DEBUGGING) Then
		SaveData
	End If
		
End Sub

Sub Activity_Click
	
	DismissPanels
		
End Sub

Sub btnCancel_Click

	mblnCancel = True	
	Activity.Finish
	
End Sub

Sub btnDbgSave_Click
	
	SaveData
	Activity.Finish
	
End Sub

Sub btnDelete_Click
	
	Msgbox2Async("Delete this list entirely?", "", "Yes", "", "No", Null, True)
	Wait For Msgbox_Result (Result As Int) 
	If Result <> DialogResponse.POSITIVE Then
		Return
	End If

	Dim intCnt1 As Int
	Dim strFile As String
	Dim FilesFound As List = File.ListFiles(Starter.gstrDir)
	Dim mlr As MainListRow = Main.glstSelectedLists.Get(0)
	
	File.Delete(Starter.gstrDir, Module1.ListFilename(mlr.ListName))
	File.Delete(Starter.gstrDir, Module1.PickedFilename(mlr.ListName))

	For intCnt1 = FilesFound.Size-1 To 0 Step -1
		strFile = FilesFound.Get(intCnt1)
		If strFile.StartsWith("Extra_" & lblListNo.Text & "_") Then
			File.Delete(Starter.gstrDir, FilesFound.Get(intCnt1))
		End If
	Next

	Dim lstMain As List = File.ReadList(Starter.gstrDir, Main.gstrMainList)
	Dim mlrM As MainListRow
	For intCnt1 = 0 To lstMain.Size-1
		mlrM = Module1.ConvertStringToType_MainListRow(lstMain.Get(intCnt1))
		If mlrM.ListNo = mlr.ListNo Then
			lstMain.RemoveAt(intCnt1)
			Exit
		End If
	Next
	File.WriteList(Starter.gstrDir, Main.gstrMainList, lstMain)
	mblnCancel = True		'so won't save on exit
	'txtLongName.Text = ""	'so won't save on exit
	Activity.Finish
	
End Sub

Sub btnOk_Click

	SaveData
	Activity.Finish
	
End Sub

Sub chkUseMaster_CheckedChange(Checked As Boolean)

	txtMasterFile.Visible = Checked
	lblMasterFile.Visible = Checked
	chkMasterImm.Visible = Checked
	lblMasterImm.Visible = Checked
	chkMasterKbd.Visible = Checked
	lblMasterKbd.Visible = Checked
	If Checked And txtMasterFile.Text = "" Then	
		txtMasterFile.Text = txtShortName.Text & "_master"
	End If
	
End Sub

'
' Rtn whether any panel was visible/dismissed
'
Sub DismissPanels As Boolean
	
	Dim blnRtn As Boolean
	
	If pnlColorPicker.Visible Then
		pnlColorPicker.Visible = False
		blnRtn = True
	End If
	Return blnRtn
	
End Sub

Sub lblColour_Click

	cvsColorPicker.Initialize(pnlColorPicker)
	pnlColorPicker.Visible = True
	
End Sub	

Sub lblColour_LongClick

	Dim inpNewColor As ColorDialog		'rtns -1=posbtn, -2=negbtn, -3=canbtn or back  : Lib:Dialogs
	inpNewColor.RGB = lblColour.Tag
	If inpNewColor.Show("", "Ok", "", "", Null) = DialogResponse.POSITIVE Then
		lblColour.Tag = inpNewColor.RGB
		lblColour.Color = lblColour.Tag 
		txtColourNo.Text = LibConv.lib_DecimalToHex(lblColour.Tag)
	End If
	
End Sub

Sub LoadData

	Dim lstMain As List = File.ReadList(Starter.gstrDir, Main.gstrMainList)
	Dim intCnt1 As Int 
	Dim intCnt2 As Int
	Dim blnNextItemIsCurrent As Boolean
	Dim intSpinnerIndex As Int = 999
	Dim mlr As MainListRow
	
	If Main.glstSelectedLists.Size > 1 Then
		Activity.Finish
	End If

	Activity.LoadLayout("editlist")
	svw1.Panel.LoadLayout("editlistdetail")
	btnDbgSave.Visible = DEBUGGING

	If Main.glstSelectedLists.Size > 0 Then
		mlr = Main.glstSelectedLists.Get(0)
		Activity.Title = mlr.ListAbbr

		lblListNo.text = mlr.ListNo
		txtLongName.text = mlr.ListName
		txtShortName.text = mlr.ListAbbr
		chkDelSrcWhenPicked.Checked = mlr.DelSrcWhenPicked
		chkHighlightCnt.Checked = mlr.HighlightCnt 
		txtMasterFile.Text = mlr.MasterList
		chkMasterImm.Checked = mlr.MasterImm
		chkMasterKbd.Checked = mlr.MasterKbd
		chkUseMaster.Checked = (txtMasterFile.Text<>"")
		lblColour.Tag = Colors.RGB(mlr.R, mlr.G, mlr.B)
		lblColour.Color = lblColour.Tag 
		txtColourNo.Text = LibConv.lib_DecimalToHex(lblColour.Tag)
		btnDelete.Visible = True
	Else
		' Find unused ListNo
		For intCnt1 = 1 To 999
			For intCnt2 = 0 To Main.glstAllLists.Size-1
				mlr = Main.glstAllLists.Get(intCnt2)
				If mlr.ListNo = intCnt1 Then
					Exit
				End If
			Next
			If intCnt2 >= Main.glstAllLists.Size Then
				Exit
			End If
		Next
		lblListNo.Text = intCnt1
		lblColour.Tag = Colors.Black
		lblColour.Color = lblColour.Tag 
		txtColourNo.Text = LibConv.lib_DecimalToHex(lblColour.Tag)
		btnDelete.Visible = False
	End If
	txtMasterFile.Visible = chkUseMaster.Checked
	lblMasterFile.Visible = chkUseMaster.Checked
	chkMasterImm.Visible = chkUseMaster.Checked
	lblMasterImm.Visible = chkUseMaster.Checked
	chkMasterKbd.Visible = chkUseMaster.Checked
	lblMasterKbd.Visible = chkUseMaster.Checked

	For intCnt1 = 0 To lstMain.Size-1
		mlr = Module1.ConvertStringToType_MainListRow(lstMain.Get(intCnt1))
		If mlr.ListName <> Null Then
			If mlr.ListNo = lblListNo.Text Then
				If intCnt1 < lstMain.Size-1 Then
					intSpinnerIndex = -1
				Else
					intSpinnerIndex = 999	'end
				End If
				blnNextItemIsCurrent = True
			Else
				If blnNextItemIsCurrent Then
					spnListNames.Add(mlr.ListName & "*")
					blnNextItemIsCurrent = False
				Else
					spnListNames.Add(mlr.ListName)
				End If
				If intSpinnerIndex = -1 Then
					intSpinnerIndex = spnListNames.Size-1
				End If
			End If
		End If
	Next
	If blnNextItemIsCurrent Then
		spnListNames.Add("[End]*")
	Else
		spnListNames.Add("[End]")
	End If
	If intSpinnerIndex = 999 Then
		intSpinnerIndex = spnListNames.Size-1
	End If
	spnListNames.SelectedIndex = intSpinnerIndex

	chkAutoSelSngResFrmVcAdd.Checked = LibGen.lib_GetINIstring(False, "", "AutoSelSngResFrmVcAdd", True)
	chkHidePkdWhnRbldMultiLst.Checked = LibGen.lib_GetINIstring(False, "", "HidePkdWhnRbldMultiLst", True)
	
End Sub

Sub pnlColorPicker_Touch (Action As Int, X As Float, Y As Float)

	Dim cx = pnlColorPicker.Width / 2, cy = pnlColorPicker.Height / 2 As Float
	If Sqrt(Power(x - cx, 2) + Power(y - cy, 2)) > pnlColorPicker.Width / 2 Then Return
	Dim clr As Int = cvsColorPicker.Bitmap.GetPixel(X, Y)
	lblColour.Tag = clr
	lblColour.Color = clr
	txtColourNo.Text = LibConv.lib_DecimalToHex(lblColour.Tag)
		
End Sub

' **Because this proc is called from Activity_Pause, it can't stop in debugger
' The workaround is to set DEBUGGING=True at the top and use btnDbgSave
Sub SaveData
	
	Dim lstMain As List = File.ReadList(Starter.gstrDir, Main.gstrMainList)
	Dim mlr As MainListRow
	Dim mlrM As MainListRow
	Dim intCnt1 As Int
	Dim intCnt2 As Int
	Dim strOldFile As String
	Dim strNewFile As String
	Dim strSpinnerItem As String = spnListNames.SelectedItem

	If lblListNo.Text = "" Or txtLongName.Text = "" Then
		Return
	End If
	If strSpinnerItem.EndsWith("*") Then
		strSpinnerItem = strSpinnerItem.SubString2(0, strSpinnerItem.Length-1)
	End If
	
	' Create new MLR from form data
	mlr.ListNo = lblListNo.text
	mlr.ListName = txtLongName.text
	mlr.ListAbbr = txtShortName.text
	mlr.DelSrcWhenPicked = chkDelSrcWhenPicked.Checked
	mlr.HighlightCnt = chkHighlightCnt.Checked
	If chkUseMaster.Checked Then
		mlr.MasterList = txtMasterFile.Text
		mlr.MasterImm = chkMasterImm.Checked 
		mlr.MasterKbd = chkMasterKbd.Checked 
	Else
		mlr.MasterList = ""
		mlr.MasterKbd = False
	End If
	Dim inpNewColor As ColorDialog
	inpNewColor.RGB = lblColour.Tag
	mlr.R = inpNewColor.Red
	mlr.G = inpNewColor.Green
	mlr.B = inpNewColor.Blue

	' Look for matching entry in _lists.txt and replace
	For intCnt1 = 0 To lstMain.Size-1
		mlrM = Module1.ConvertStringToType_MainListRow(lstMain.Get(intCnt1))
		If mlrM.ListNo = lblListNo.Text Then
			If mlr.ListName <> mlrM.ListName Then
				' List renamed
				strOldFile = Module1.ListFilename(mlrM.ListName)
				strNewFile = Module1.ListFilename(mlr.ListName)
				LibGen.lib_RenameFile(Starter.gstrDir, strOldFile, strNewFile)
				strOldFile = Module1.PickedFilename(mlrM.ListName)
				strNewFile = Module1.PickedFilename(mlr.ListName)
				LibGen.lib_RenameFile(Starter.gstrDir, strOldFile, strNewFile)
			End If
			' Test if master list deleted or renamed (added handled at bottom)
			If mlr.MasterList = "" Then
				If mlrM.MasterList <> "" Then
					' Deleted
					strOldFile = Module1.ListFilename(mlrM.MasterList)
					If File.Exists(Starter.gstrDir, strOldFile) Then
						File.Delete(Starter.gstrDir, strOldFile)
					End If
				End If
			Else
				If mlrM.MasterList <> "" Then
					If mlr.MasterList <> mlrM.MasterList  Then
						' Renamed
						strOldFile = Module1.ListFilename(mlrM.MasterList)
						strNewFile = Module1.ListFilename(mlr.MasterList)
						If File.Exists(Starter.gstrDir, strOldFile) Then
							' No handling if new name already exists
							LibGen.lib_RenameFile(Starter.gstrDir, strOldFile, strNewFile)		
						End If
					End If
				End If
			End If
			' Update main list
			lstMain.Set(intCnt1, Module1.ConvertTypeToString_MainListRow(mlr))
			If mlr.DelSrcWhenPicked Then
				Module1.RemoveAllPickedItems(mlr)
			End If
			Exit
		End If
	Next
	
	If intCnt1 >= lstMain.Size Then
		' No matching entry in _lists.txt
		If strSpinnerItem = "[End]" Then
			lstMain.Add(Module1.ConvertTypeToString_MainListRow(mlr))
		Else
			For intCnt2 = 0 To lstMain.Size-1
				mlrM = Module1.ConvertStringToType_MainListRow(lstMain.Get(intCnt2))
				If mlrM.ListName = strSpinnerItem Then
					lstMain.InsertAt(intCnt2, Module1.ConvertTypeToString_MainListRow(mlr))	
					Exit
				End If
			Next
		End If
	Else
		' Matching entry in _lists.txt, look for index this entry is moving before
		If strSpinnerItem = "[End]" Then
			LibConv.lib_ListMoveItem(lstMain, intCnt1, lstMain.Size)
		Else
			For intCnt2 = 0 To lstMain.Size-1
				mlrM = Module1.ConvertStringToType_MainListRow(lstMain.Get(intCnt2))
				If mlrM.ListName = strSpinnerItem Then
					LibConv.lib_ListMoveItem(lstMain, intCnt1, intCnt2)
					Exit
				End If
			Next
		End If
	End If
	File.WriteList(Starter.gstrDir, Main.gstrMainList, lstMain)

	' Ensure master file exists	
	If mlr.MasterList <> "" Then
		strNewFile = Module1.ListFilename(mlr.MasterList)
		If Not(File.Exists(Starter.gstrDir, strNewFile)) Then
			File.WriteString(Starter.gstrDir, strNewFile, "")
		End If
	End If

	LibGen.lib_SetINIstring(False, "", "AutoSelSngResFrmVcAdd", chkAutoSelSngResFrmVcAdd.Checked)
	LibGen.lib_SetINIstring(False, "", "HidePkdWhnRbldMultiLst", chkHidePkdWhnRbldMultiLst.Checked)

End Sub

Sub txtColourNo_TextChanged (Old As String, New As String)

	Try
		If IsNumber(LibConv.lib_HexToDecimal(txtColourNo.Text)) Then
			lblColour.Tag = -LibConv.lib_HexToDecimal(txtColourNo.Text)
			lblColour.Color = lblColour.Tag
		End If
	Catch
		Return
	End Try	
	
End Sub

Sub txtLongName_TextChanged (Old As String, New As String)

	txtShortName.text = New
	
End Sub
