﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

	Dim TTS1 As TTS					'lib TTS
	'Dim VR As VoiceRecognition		'lib Phone
    Dim SR As SpeechToText			'lib SpeechToText https://www.b4x.com/android/forum/threads/another-speechrecognizer-library.37584/
    Dim SRri As RecognizerIntent
    Dim SRi As Intent
	Dim const QU_END As Int = 0
	Dim const QU_NOTE As Int = 3
	Dim const QU_STAYOPEN As Int = 99
		
End Sub

Sub Globals
	
	Private lblMasterRow As Label
	Private chkMasterRow As CheckBox
	Private clvMasterList As CustomListView
	Private txtFilter As EditText
	Private mblnLoadingList As Boolean
	Private mintQuestionNo As Int
	Private mblnVoiceFilter As Boolean
	Private const MINFILTERLEN As Int = 1
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	Activity.AddMenuItem3("Add item not from master list", "mnuAddNew", LoadBitmap(File.DirAssets, "ic_input_add.png"), True)
	Activity.AddMenuItem3("Add item to master list", "mnuAddToMst", LoadBitmap(File.DirAssets, "ic_input_adddbl.png"), True)
	Activity.AddMenuItem3("VoiceAdd", "mnuVoiceAdd", LoadBitmap(File.DirAssets, "perm_group_voicemail.png"), True)			
	TTS1.Initialize("TTS1")
	'VR.Initialize("VR")
    SR.initialize("SR")
	If Not(SR.isRecognitionAvailable) Then
		MsgboxAsync("Voice recognition not available", "Error")
		Wait For Msgbox_Result
		Activity.Finish
		Return
	End If
    SRi.Initialize(SRri.ACTION_VOICE_SEARCH_HANDS_FREE,"")
    SRi.PutExtra(SRri.EXTRA_CALLING_PACKAGE,"com.inforpires.testSpeech")
    SRi.PutExtra(SRri.EXTRA_LANGUAGE_MODEL, SRri.LANGUAGE_MODEL_FREE_FORM)
    'SRi.PutExtra(ri.EXTRA_LANGUAGE,"en_NZ")
    SRi.PutExtra(SRri.EXTRA_MAX_RESULTS,1)
    SRi.PutExtra(SRri.EXTRA_PARTIAL_RESULTS,True)
    SR.createSpeechRecognizer

	Activity.LoadLayout("Masterlist")
	'LoadList("", "")
	txtFilter.RequestFocus
	
End Sub

Sub Activity_Resume

	Dim lblLoading As Label
	lblLoading.Initialize("")
	lblLoading.Text="Loading..."
	Activity.AddView(lblLoading,0,0,100%x,40dip)
	Sleep(0)
	If txtFilter.IsInitialized Then
		LoadList(txtFilter.Text, "")
	End If
	lblLoading.RemoveView
		
End Sub

Sub Activity_Pause (UserClosed As Boolean)

	If UserClosed Then
		SR.destroy
	End If
	
End Sub

Sub btnClearFilter_Click
	
	If txtFilter.Text = "" Then
		LoadList("", "")
	Else
		txtFilter.Text = ""
	End If

End Sub

Sub chkMasterRow_CheckedChange(Checked As Boolean)

	If Not(mblnLoadingList) Then
		SaveSelections
	End If
	
End Sub

Sub lblMasterRow_Click

	Dim intIndex As Int = clvMasterList.GetItemFromView(Sender)
	Dim pnl As Panel = clvMasterList.GetPanel(intIndex)
	Dim chk As CheckBox = pnl.GetView(0)
	
	chk.Checked = Not(chk.Checked)
	SaveSelections
	
End Sub

Sub ListenForSpeech
	'VR.Listen
	LibGen.lib_ToastMessage("Listening...", 1000, Colors.Blue)
	'lblListening.Visible = True
	SR.startListening(SRi)
End Sub
'
' This activity only called when a single list, so can assume Main.glstSelectedLists.Get(0)
'
Sub LoadList(pstrFilter As String, pstrSelectItem As String)
	
	Dim blnFilter As Boolean = (pstrFilter <> "")
	Dim blnInclude As Boolean
	Dim lstUser As List
	Dim lstMaster As List
	Dim intCnt1 As Int
	Dim intCnt2 As Int
	Dim intSelectedIndex As Int = -1
	Dim strLine As String
	Dim strFilterParts() As String
 	Dim pnl As Panel
	Dim mlr As MainListRow = Main.glstSelectedLists.Get(0)

	If blnFilter Then
		If pstrFilter.Length < MINFILTERLEN Then
			Return
		End If
		pstrFilter = pstrFilter.ToLowerCase
		strFilterParts = Regex.Split(" ", pstrFilter)
	End If
	mblnLoadingList = True
	clvMasterList.Clear

	lstMaster.Initialize
	lstMaster = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.MasterList))
	Do Until lstMaster.IndexOf("") = -1		'not sure why we might get a blank, but had one and its a pain
		lstMaster.RemoveAt(lstMaster.IndexOf(""))
		File.WriteList(Starter.gstrDir, Module1.ListFilename(mlr.MasterList), lstMaster)
	Loop
	lstMaster.Sort(True)
	lstUser = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.ListName))
	For intCnt1 = 0 To lstMaster.Size-1
		strLine = lstMaster.Get(intCnt1)
		If Not(strLine.StartsWith("--")) Then
			blnInclude = True
			If blnFilter Then
				' This will match 'coffee (beans)' when filter = 'coffee beans' but unlike VBs like cmd, it will also match when filter = 'beans coffee'
				' Not exactly how I want it but easiest to code and close enough. Might actually be a good idea after all.
				For intCnt2 = 0 To strFilterParts.Length-1
					blnInclude = blnInclude And strLine.ToLowerCase.Contains(strFilterParts(intCnt2))	
				Next
			End If
			If blnInclude Then
				pnl.Initialize("")
				pnl.SetLayout(0, 0, clvMasterList.AsView.Width, 40dip) 'set the panel size before you load the layout.
				pnl.LoadLayout("Masterrow")
				lblMasterRow.Text = strLine
				lblMasterRow.TextColor = Colors.Black
				chkMasterRow.Checked = (lstUser.IndexOf(strLine) >= 0)
				pnl.Color = Colors.White
				clvMasterList.Add(pnl, 40dip)
				
				If strLine = pstrSelectItem Then
					intSelectedIndex = clvMasterList.GetSize-1
				End If
			End If
		End If
	Next
	clvMasterList.AsView.Height = Min(100%y-txtFilter.Height, clvMasterList.GetSize*41dip+1dip)	'stops bottom of scrn being all divider color. 41=40+divheight + 1 for last div

	If intSelectedIndex >= 0  Then
		Sleep(0)
		clvMasterList.JumpToItem(intSelectedIndex)
		pnl = clvMasterList.GetPanel(intSelectedIndex)
		pnl.SetColorAnimated(1000, Colors.RGB(255,140,0), Colors.White)			'dark orange  | 255,165,0=orange
	End If	

	If mblnVoiceFilter Then
		If clvMasterList.GetSize = 1 Then
			If LibGen.lib_GetINIstring(False, "", "AutoSelSngResFrmVcAdd", True) Then
				chkMasterRow.Checked = True			'if only ine entry, this var must be current
				SaveSelections
			End If
		End If
		mblnVoiceFilter = False
	End If

	If mlr.MasterKbd Then
		Sleep (250)
		Dim ime As IME		'requires lib IME
		ime.Initialize("") 
		ime.ShowKeyboard(txtFilter)
	End If
	mblnLoadingList = False

End Sub
'
' Add a new item that is NOT from the master list
'
Sub mnuAddNew_Click

	Dim lstUser As List
	Dim intCnt1 As Int
	Dim strParts() As String
	Dim strNewItem As String
	Dim mlr As MainListRow = Main.glstSelectedLists.Get(0)

	strNewItem = txtFilter.Text.Trim
	If strNewItem = "" Then
		Return
	End If
	
	'Wait For(libloc_MultilineInputDialog(txtFilter.Text, False)) Complete (strInput As String)
	'If strInput <> "" And strInput <> QUOTE Then
		strParts = Regex.Split(CRLF, Module1.CleanItemName(strNewItem))	'strInput))
		lstUser = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.ListName))
		For intCnt1 = 0 To strParts.Length-1
			If lstUser.IndexOf(strParts(intCnt1)) < 0 Then
				lstUser.Add(strParts(intCnt1))		'autoadd it as a selected item in user list
			End If
		Next
		File.WriteList(Starter.gstrDir, Module1.ListFilename(mlr.ListName), lstUser)
		Activity.Finish
		'LoadList(txtFilter.Text, strParts(0))
	'End If
	
End Sub

Sub mnuAddToMst_Click
	
	Dim lstUser As List
	Dim lstMaster As List
	Dim strNewItem As String
	Dim mlr As MainListRow = Main.glstSelectedLists.Get(0)

	strNewItem = txtFilter.Text.Trim
	If strNewItem = "" Then
		Return
	End If
	
	lstMaster = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.MasterList))
	lstUser = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.ListName))
	If lstMaster.IndexOf(strNewItem) < 0 Then
		lstMaster.Add(strNewItem)
	End If
	If lstUser.IndexOf(strNewItem) < 0 Then
		lstUser.Add(strNewItem)		'autoadd it as a selected item in user list
	End If
	File.WriteList(Starter.gstrDir, Module1.ListFilename(mlr.MasterList), lstMaster)
	File.WriteList(Starter.gstrDir, Module1.ListFilename(mlr.ListName), lstUser)
	txtFilter.Text = ""
	LoadList("", strNewItem)
	
End Sub

Sub mnuVoiceAdd_Click

	mintQuestionNo = QU_NOTE		'jump to record note
	'SpeakTTS(mstrSpeech_Record & " item", "Record item")		
	ListenForSpeech
	
End Sub

Sub Questions(pblnTextToSpeechFinished As Boolean, Texts As List)

	Dim strSpeech As String
	
	'LibGen.lib_DebugLog("Questions: QuNo=" & mintQuestionNo & ": TTSfinished=" & pblnTextToSpeechFinished & ": TextsSize=" & Texts.Size, True)
	If Not(pblnTextToSpeechFinished) Then
		If Texts.Size > 0 Then
			strSpeech = Texts.Get(0)
			strSpeech = strSpeech.ToLowerCase
		End If
		'LibGen.lib_DebugLog("Text0=" & strSpeech, True)
	End If
	If Not(pblnTextToSpeechFinished) And strSpeech = "cancel" Then
		mintQuestionNo = QU_STAYOPEN
		'SpeakTTS("Cancel", "")
	Else
		Select mintQuestionNo
			Case QU_END
				Activity.Finish
			Case QU_NOTE
				If pblnTextToSpeechFinished Then 	'(TTSfinished)
					ListenForSpeech
				Else								'(VRresult)
					Select strSpeech
						Case Else
							mintQuestionNo = QU_STAYOPEN
							mblnVoiceFilter = True
							txtFilter.Text = Texts.Get(0)
'							'Sleep(50)
'							' txtFilter_TextChanged() should have been called by now
'							Log("2")
'							If clvMasterList.GetSize = 1 Then
'								Dim pnl As Panel = clvMasterList.GetPanel(0)
'								Dim chk As CheckBox = pnl.GetView(0)
'								Dim lbl As Label = pnl.GetView(1)
'								Log("3")
'								Log(lbl.Text)
'								Log(chk.Checked)
'								chk.Checked = True
'								Log(chk.Checked)
'								Log("4")
'							End If
					End Select
				End If
		End Select
	End If
		
End Sub

Sub SaveSelections

	Dim lstUser As List
	Dim pnl As Panel
	Dim lbl As Label
	Dim chk As CheckBox
	Dim mlr As MainListRow = Main.glstSelectedLists.Get(0)
	
	' Activity_Create/LoadList preticked everything in user list, now we just overwrite that list with whats ticked now
	lstUser = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.ListName))
	For intCnt1 = 0 To clvMasterList.GetSize-1
		pnl = clvMasterList.GetPanel(intCnt1)
		chk = pnl.GetView(0)
		lbl = pnl.GetView(1)
		If lstUser.IndexOf(lbl.Text) < 0 Then
			If chk.Checked Then
				lstUser.Add(lbl.Text)
			End If
		Else
			If Not(chk.Checked) Then
				lstUser.RemoveAt(lstUser.IndexOf(lbl.Text))
			End If
		End If
	Next
	File.WriteList(Starter.gstrDir, Module1.ListFilename(mlr.ListName), lstUser)
	
End Sub

Sub SR_onResults(Texts As Object)
	'lblListening.Visible = False
	Questions(False, Texts)
End Sub
Sub SR_onError(ErrNo As Int)

    Select Case ErrNo
        Case 1
            Log("Error: " & ErrNo & " network timeout")
        Case 2
            Log("Error: " & ErrNo & " error network")
        Case 3
            Log("Error: " & ErrNo & " error audio recording")
        Case 4
            Log("Error: " & ErrNo & " error server")
        Case 5
            Log("Error: " & ErrNo & " error client")       
        Case 6
            Log("Error: " & ErrNo & " speech timeout")       
        Case 7
            Log("Error: " & ErrNo & " no match")		'timeout listening for speech (so what is err 6?)
	        ListenForSpeech
			Return
        Case 8
            Log("Error: " & ErrNo & " recognizer busy")
	        SR.stopListening
	        SR.destroy
	        SR.createSpeechRecognizer
	        ListenForSpeech
			Return
        Case 9
            Log("Error: " & ErrNo & " insufficient permissions")
        Case Else
            Log("Error: " & ErrNo & " Unknown error")
    End Select

	mintQuestionNo = QU_END
	'SpeakTTS("FAILED", "")
    
End Sub
Sub SR_onEndOfSpeech
    Log("SR_onEndOfSpeech")
End Sub

Sub txtFilter_TextChanged (Old As String, New As String)

	If New <> "" Then
		LoadList(New, "")
'		If New.Length >= MINFILTERLEN Then
'			Dim lstMaster As List
'			Dim mlr As MainListRow = Main.glstSelectedLists.Get(0)
'			lstMaster = File.ReadList(Starter.gstrDir, Module1.ListFilename(mlr.MasterList))
'			btnAddToMaster.Enabled = (lstMaster.IndexOf(New)<0)
'		Else
'			btnAddToMaster.Enabled = False
'		End If
'	Else
'		btnAddToMaster.Enabled = False
	End If
		
End Sub

'Sub VR_Result(Success As Boolean, Texts As List)
'	
'	If Success = True Then
'		Questions(False, Texts)
'	Else
'		mintQuestionNo = QU_STAYOPEN	'QU_END
'		'SpeakTTS("FAILED", "")
'	End If
'	
'End Sub

'
' Because it uses async calls, it is a resumable sub, so can't simply return a value.
' Has to go in an activity module, so can't go in Lib module (which is static)
' Calling syntax: Wait For(libloc_MultilineInputDialog(False)) Complete (strInput As String)
' Returns: text if accepted, empty text if user cleared (or entered no text), QUOTE if user pressed back key (so do nothing)
' v3	- in some scenarios the kbd doesn't show without a delay, and sometimes pops up again after. added sleeps etc.
' v2c   - check for some text before setting SelectionStart to 1 (only gave err in one app at one time)
' v2b   - SelectionStart to put cursor at top
' v2a   - SetSize(92%) was 100% but on android10/S10e get white band
' v2    - StateManager
' v1.1a - descr chg only
'
Sub libloc_MultilineInputDialog(pstrText As String, pblnWrap As Boolean) As ResumableSub
	
	Dim cd As CustomLayoutDialog	'requires lib Dialogs
	
	cd.ShowAsync("", "Ok", "", "Clear", Null, True)
	cd.SetSize(92%x, 50%y) 'request maximum size
	Wait For Dialog_Ready (DialogPanel As Panel)
	Dim txt As EditText
	txt.Initialize("libloc_MultilineInputDialog")
	txt.SingleLine = False
	txt.Wrap = pblnWrap
	If pstrText = "" Then
		txt.Text = StateManager.GetSetting("Txt")
	Else
		txt.Text = pstrText
	End If
	txt.Color = Colors.RGB(224, 255, 255) 	'LightCyan
	txt.TextColor = Colors.Black
	txt.InputType = Bit.Or(txt.InputType, 524288)	'disable spellcheck
	txt.Gravity = Gravity.TOP + Gravity.LEFT
	If txt.Text.Length > 0 Then
		txt.SelectionStart = 1	'if don't set to 1 first it doesn't go to 0
	End If
	txt.SelectionStart = 0
	DialogPanel.AddView(txt, 0, 0, 92%x, 50%y)
	Dim ime As IME		'requires lib IME
	ime.Initialize("") 
	Sleep(100)			'seem to need longish sleep here to get kbd to show depending on what was done before calling this
	ime.ShowKeyboard(txt)
	Wait For Dialog_Result(Result As Int)
	Sleep(100)			'in some scenarios the kbd
	ime.HideKeyboard	'  pops up again after
	StateManager.SetSetting("Txt", "")
	StateManager.SaveSettings 
	If Result = DialogResponse.POSITIVE Then
		Return txt.Text
	else If Result = DialogResponse.NEGATIVE Then
		Return ""
	Else
		Return QUOTE	'flag to do nothing
	End If

End Sub
Sub libloc_MultilineInputDialog_TextChanged (Old As String, New As String)
	StateManager.SetSetting("Txt", New)
	StateManager.SaveSettings
End Sub
