﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=10.85
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals
	
	
	Dim mlstMaster As List
	Dim mmlr As MainListRow 
	Private mblnUpdating As Boolean
	Private mblnSearchInProgress As Boolean

	Private btnClearSearch As Button
	Private lblDown As Label
	Private lblUp As Label
	Private txtSearch As EditText
	Private ulvModMasterList As UltimateListView
	
End Sub

Sub Activity_Create(FirstTime As Boolean)

	Activity.AddMenuItem3("Add", "mnuAddNew", LoadBitmap(File.DirAssets, "ic_input_add.png"), True)
	Activity.AddMenuItem3("Del selected items", "mnuDelete", LoadBitmap(File.DirAssets, "ic_menu_delete.png"), True)

End Sub

Sub Activity_Resume

	Dim lblLoading As Label
	lblLoading.Initialize("")
	lblLoading.Text = "Loading..."
	Activity.AddView(lblLoading,0,0,100%x,40dip)
	Sleep(0)
	LoadList
	lblLoading.RemoveView
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)

	If ulvModMasterList.IsDragStarted Then
		ulvModMasterList.CancelDrag
	End If

End Sub

Private Sub btnClearSearch_Click

	txtSearch.Text = ""
	lblUp.Tag = ""
	
End Sub

Private Sub ItemChk_CheckedChange(Checked As Boolean)
	
	If Not(mblnUpdating) Then
		ulvModMasterList.SetSelected(ulvModMasterList.GetPositionForID(ulvModMasterList.FindIDInVisibleItems(Sender), True), Checked)
	End If
	
End Sub

Sub lblDown_Click

	If mblnSearchInProgress Then
		Return
	End If

	Dim ime As IME		'requires lib IME
	ime.Initialize("") 
	ime.HideKeyboard

	Dim intItemID As Int
	If Not(IsNumber(lblUp.Tag)) Then
		intItemID = -1
	Else
		intItemID = lblUp.Tag
	End If
	SearchFor(txtSearch.Text, True, intItemID, False)
		
End Sub

Sub lblUp_Click

	If mblnSearchInProgress Then
		Return
	End If

	Dim ime As IME		'requires lib IME
	ime.Initialize("") 
	ime.HideKeyboard

	Dim intItemID As Int
	If Not(IsNumber(lblUp.Tag)) Then
		intItemID = -1
	Else
		intItemID = lblUp.Tag
	End If
	SearchFor(txtSearch.Text, False, intItemID, False)

End Sub

Sub mnuAddNew_Click

	Dim strParts() As String
	Dim strItem As String
	Dim intCnt1 As Int
	
	Wait For(libloc_MultilineInputDialog("", False)) Complete (strInput As String)
	If strInput <> "" And strInput <> QUOTE Then
		strParts = Regex.Split(CRLF, Module1.CleanItemName(strInput))
		For intCnt1 = strParts.Length-1 To 0 Step -1
			strItem = Module1.CleanItemName(strParts(intCnt1))
			If mlstMaster.IndexOf(strItem) < 0 Then
				mlstMaster.InsertAt(0, strItem)
			End If
		Next
		File.WriteList(Starter.gstrDir, Module1.ListFilename(mmlr.MasterList), mlstMaster)
		LoadList
	End If
	
End Sub

Sub mnuDelete_Click

	Dim lstSelecteds As List = ulvModMasterList.GetSelectedIDs
	Dim intCnt1 As Int
	
	If lstSelecteds.Size < 1 Then
		Return
	End If
	
	' List might have been drag/dropped order changed. That updates underlying list without running LoadList, so now underlying list order
	' is same as current Position but RowID is outdated. So first update selectedIDs.
	For intCnt1 = 0 To lstSelecteds.Size-1
		lstSelecteds.Set(intCnt1, ulvModMasterList.GetPositionForID(lstSelecteds.Get(intCnt1),False ) )
	Next
	lstSelecteds.Sort(False)
	
	For intCnt1 = 0 To lstSelecteds.Size-1
		mlstMaster.RemoveAt(lstSelecteds.Get(intCnt1))
	Next
	File.WriteList(Starter.gstrDir, Module1.ListFilename(mmlr.MasterList), mlstMaster)

	LoadList
	
End Sub

Private Sub txtSearch_TextChanged (Old As String, New As String)

	If New = "" Then
		lblDown.SetBackgroundImage(LoadBitmap(File.DirAssets, "ic_find_next_holo_dark.png"))
		lblDown.Enabled = False
		lblUp.SetBackgroundImage(LoadBitmap(File.DirAssets, "ic_find_previous_holo_dark.png"))	
		lblUp.Enabled = False
	Else
		SearchFor(New, True, -1, False)
	End If

End Sub

Private Sub ulvModMasterList_CellClick(RowID As Long, CellIndex As Byte, Position As Int, ClickedPanel As Panel)
	'Log("ulvModMasterList_CellClick: RowID=" & RowID & ",CellIndex=" & CellIndex)
	
	Select Case CellIndex
	'Case 0
		'don't need this as clicking row calls Item_RowLayoutCreator which sets checkbox
	'Case 1
'	Case 2
'		Wait For(libloc_MultilineInputDialog("", False)) Complete (strInput As String)
'		If strInput <> "" And strInput <> QUOTE Then
'			Log(strInput)
'		End If		
	End Select
	
End Sub

Private Sub ulvModMasterList_CellLongClick(RowID As Long, CellIndex As Byte, Position As Int, ClickedPanel As Panel)
	
	Select Case CellIndex
	'Case 0
	Case 1	'Rename
		Dim lbl As Label = ClickedPanel.GetView(0)
		Dim strInput As String
		Dim intIndex As Int
		Dim inpNewText As InputDialog		'rtns -1=posbtn, -2=negbtn, -3=canbtn or back  : Lib:Dialogs

		inpNewText.Input = lbl.Text
		If inpNewText.Show("", "", "Ok", "", "", Null) = DialogResponse.POSITIVE Then
			strInput = Module1.CleanItemName(inpNewText.Input)
			If strInput = "" Or strInput = lbl.Text Then
				Return
			End If			
			intIndex = mlstMaster.IndexOf(lbl.Text)
			mlstMaster.Set(intIndex, strInput)		
			File.WriteList(Starter.gstrDir, Module1.ListFilename(mmlr.MasterList), mlstMaster)
			ulvModMasterList.RefreshContent
		End If
	Case 2
		ulvModMasterList.StartDrag(Position, True, Null)
	End Select
	
End Sub

Sub ulvModMasterList_Dropped(DropView As View, StartPosition As Int, DropPosition As Int)

	Dim lst As List

	lst.Initialize 
	
	' Move item in underlying list
	' ULV doesn't seem to let me just read the whole list and write in that order to disk
	lst = File.ReadList(Starter.gstrDir, Module1.ListFilename(mmlr.MasterList))		'can't use mlstList to do with index/order
	If DropPosition < StartPosition Then
		lst.InsertAt(DropPosition, lst.Get(StartPosition))
		lst.RemoveAt(StartPosition+1)
	else If DropPosition > StartPosition Then
		If DropPosition = ulvModMasterList.NumberOfItems-1 Then
			lst.Add(lst.Get(StartPosition))
			lst.RemoveAt(StartPosition)
		Else
			lst.InsertAt(DropPosition+1, lst.Get(StartPosition))
			lst.RemoveAt(StartPosition)
		End If
	Else
		Return
	End If
	File.WriteList(Starter.gstrDir, Module1.ListFilename(mmlr.MasterList), lst)
	ulvModMasterList.RefreshContent
	
End Sub

Sub LoadList
	
	Dim intCnt1 As Int
	
	If Main.glstSelectedLists.Size > 1 Then
		Activity.Finish
	Else
		mmlr = Main.glstSelectedLists.Get(0)
		Activity.Title = mmlr.ListAbbr
		Activity.LoadLayout("modmasterlist")
	End If

	ulvModMasterList.AddRowLayout("LISTROW", "Item_RowLayoutCreator", "Item_RowContentFiller", 40dip, 3, Array As Int(35dip, 100%x-85dip, 50dip), 0dip, Colors.White, True)
	
	mlstMaster = File.ReadList(Starter.gstrDir, Module1.ListFilename(mmlr.MasterList))

	ulvModMasterList.ClearContent 
	For intCnt1 = 0 To mlstMaster.Size-1
		ulvModMasterList.AddItem("LISTROW", intCnt1)
	Next

	txtSearch.RequestFocus
	
End Sub

Sub Item_RowLayoutCreator(LayoutName As String, CellPanel As Panel, CellIndex As Byte)
	
	Select Case CellIndex
	Case 0
		Dim chk As CheckBox
		chk.Initialize("ItemChk")
		CellPanel.AddView(chk, 0, 0, CellPanel.Width, CellPanel.Height)

		Dim pnl As B4XView
		Dim xui As XUI
		pnl = xui.CreatePanel("")
		pnl.SetColorAndBorder(Colors.Transparent, 1dip, LibConv.lib_GetColorIntFromHex("#FFD9D7DE"), 0)
		CellPanel.AddView(pnl, 0, 0, CellPanel.Width, 2dip)
	Case 1
		Dim lbl As Label
		lbl.Initialize("")
		lbl.Color = Colors.Transparent
		lbl.TextColor = Colors.RGB(mmlr.R, mmlr.G, mmlr.B)
		lbl.TextSize = 17
		lbl.Gravity = Gravity.CENTER_VERTICAL
		CellPanel.AddView(lbl, 0, 0, CellPanel.Width, CellPanel.Height)

		' ULV Divider is same colour as bg. I want white bg so adding panel where we can set border color.
		Dim pnl As B4XView
		Dim xui As XUI
		pnl = xui.CreatePanel("")
		pnl.SetColorAndBorder(Colors.Transparent, 1dip, LibConv.lib_GetColorIntFromHex("#FFD9D7DE"), 0)
		CellPanel.AddView(pnl, 0, 0, CellPanel.Width, 2dip)
	Case 2
		Dim lbl As Label
		lbl.Initialize("")
		'lbl.Color = Colors.Gray
		'lbl.TextColor = Colors.Black
		'lbl.TextSize = 14
		lbl.SetBackgroundImage(LoadBitmap(File.DirAssets, "scrollbar_handle_accelerated_anim2.9.png"))
		'lbl.Gravity = Gravity.CENTER_VERTICAL + Gravity.CENTER_HORIZONTAL
		CellPanel.AddView(lbl, 1dip, 1dip, CellPanel.Width-2dip, CellPanel.Height-2dip)
'		Dim btn As Button
'		btn.Initialize("ItemBtn")
'		btn.Color = Colors.Gray
'		btn.TextColor = Colors.Black
'		btn.Padding = Array As Int(5,5,5,5)
'		CellPanel.AddView(btn, 1dip, 1dip, CellPanel.Width-2dip, CellPanel.Height-2dip)

		Dim pnl As B4XView
		Dim xui As XUI
		pnl = xui.CreatePanel("")
		pnl.SetColorAndBorder(Colors.Transparent, 1dip, LibConv.lib_GetColorIntFromHex("#FFD9D7DE"), 0)
		CellPanel.AddView(pnl, 0, 0, CellPanel.Width, 2dip)
	End Select

End Sub

Sub Item_RowContentFiller(RowID As Long, LayoutName As String, CellPanel As Panel, CellIndex As Byte, Position As Int)

	Select Case CellIndex
	Case 0
		Dim chk As CheckBox = CellPanel.GetView(0)
		mblnUpdating = True
		chk.Checked = ulvModMasterList.IsSelected(Position)
		mblnUpdating = False
	Case 1
		Dim lbl As Label = CellPanel.GetView(0)
		lbl.Text = mlstMaster.Get(RowID)
'	Case 2
	End Select

End Sub

private Sub SearchFor(pstrFind As String, pblnDown As Boolean, pintFromID As Int, pblnFirstFound As Boolean)

	Dim strItem As String
	Dim intCnt1 As Int
	Dim intFromPos As Int
	Dim intFndPos As Int
	Dim blnFirstFound As Boolean = pblnFirstFound
	Dim strFind As String
	
	If Not(pblnFirstFound) Then
		If mblnSearchInProgress Then
			Return
		End If
		mblnSearchInProgress = True
		lblDown.Enabled = False
		lblUp.Enabled = False
		strFind = pstrFind.ToLowerCase
	End If
	
	intFromPos = ulvModMasterList.GetPositionForID(pintFromID, False)	'we pass ID not position so still ok after items moved around
	
	If pblnDown Then
		For intCnt1 = 0 To mlstMaster.Size-1
			strItem = mlstMaster.Get(intCnt1)
			strItem = strItem.ToLowerCase
			If strItem.Contains(strFind) Then
				intFndPos = ulvModMasterList.GetPositionForID(intCnt1, False)
				If intFndPos > intFromPos Then	
					If blnFirstFound Then
						lblDown.Enabled = True
						Exit
					Else
						ulvModMasterList.JumpTo(intFndPos, False)
						lblUp.Tag = intCnt1
						intFromPos = intFndPos
						blnFirstFound = True
						SearchFor(strFind, Not(pblnDown), intCnt1, True)		'set opp up/down button visibility
					End If
				End If
			End If
		Next
	Else
		For intCnt1 = mlstMaster.Size-1 To 0 Step -1
			strItem = mlstMaster.Get(intCnt1)
			strItem = strItem.ToLowerCase
			If strItem.Contains(strFind) Then
				intFndPos = ulvModMasterList.GetPositionForID(intCnt1, False)
				If intFndPos < intFromPos And intFndPos >=0 Then
					If blnFirstFound Then
						lblUp.Enabled = True
						Exit
					Else
						ulvModMasterList.JumpTo(intFndPos, False)
						lblUp.Tag = intCnt1
						intFromPos = intFndPos
						blnFirstFound = True
						SearchFor(strFind, Not(pblnDown), intCnt1, True)		'set opp up/down button visibility
					End If
				End If
			End If
		Next
	End If

	If Not(pblnFirstFound) Then
		If lblDown.Enabled Then
			lblDown.SetBackgroundImage(LoadBitmap(File.DirAssets, "ic_find_next_holo_light.png"))
		Else
			lblDown.SetBackgroundImage(LoadBitmap(File.DirAssets, "ic_find_next_holo_dark.png"))
		End If
		If lblUp.Enabled Then
			lblUp.SetBackgroundImage(LoadBitmap(File.DirAssets, "ic_find_previous_holo_light.png"))
		Else
			lblUp.SetBackgroundImage(LoadBitmap(File.DirAssets, "ic_find_previous_holo_dark.png"))
		End If
		mblnSearchInProgress = False
	End If
	
End Sub

'
' Because it uses async calls, it is a resumable sub, so can't simply return a value.
' Has to go in an activity module, so can't go in Lib module (which is static)
' Calling syntax: Wait For(libloc_MultilineInputDialog(False)) Complete (strInput As String)
' Returns: text if accepted, empty text if user cleared (or entered no text), QUOTE if user pressed back key (so do nothing)
' v3	- in some scenarios the kbd doesn't show without a delay, and sometimes pops up again after. added sleeps etc.
' v2c   - check for some text before setting SelectionStart to 1 (only gave err in one app at one time)
' v2b   - SelectionStart to put cursor at top
' v2a   - SetSize(92%) was 100% but on android10/S10e get white band
' v2    - StateManager
' v1.1a - descr chg only
'
Sub libloc_MultilineInputDialog(pstrText As String, pblnWrap As Boolean) As ResumableSub
	
	Dim cd As CustomLayoutDialog	'requires lib Dialogs
	
	cd.ShowAsync("", "Ok", "", "Clear", Null, True)
	cd.SetSize(92%x, 50%y) 'request maximum size
	Wait For Dialog_Ready (DialogPanel As Panel)
	Dim txt As EditText
	txt.Initialize("libloc_MultilineInputDialog")
	txt.SingleLine = False
	txt.Wrap = pblnWrap
	If pstrText = "" Then
		txt.Text = StateManager.GetSetting("Txt")
	Else
		txt.Text = pstrText
	End If
	txt.Color = Colors.RGB(224, 255, 255) 	'LightCyan
	txt.TextColor = Colors.Black
	txt.InputType = Bit.Or(txt.InputType, 524288)	'disable spellcheck
	txt.Gravity = Gravity.TOP + Gravity.LEFT
	If txt.Text.Length > 0 Then
		txt.SelectionStart = 1	'if don't set to 1 first it doesn't go to 0
	End If
	txt.SelectionStart = 0
	DialogPanel.AddView(txt, 0, 0, 92%x, 50%y)
	Dim ime As IME		'requires lib IME
	ime.Initialize("") 
	Sleep(100)			'seem to need longish sleep here to get kbd to show depending on what was done before calling this
	ime.ShowKeyboard(txt)
	Wait For Dialog_Result(Result As Int)
	Sleep(100)			'in some scenarios the kbd
	ime.HideKeyboard	'  pops up again after
	StateManager.SetSetting("Txt", "")
	StateManager.SaveSettings 
	If Result = DialogResponse.POSITIVE Then
		Return txt.Text
	else If Result = DialogResponse.NEGATIVE Then
		Return ""
	Else
		Return QUOTE	'flag to do nothing
	End If

End Sub
Sub libloc_MultilineInputDialog_TextChanged (Old As String, New As String)
	StateManager.SetSetting("Txt", New)
	StateManager.SaveSettings
End Sub
