﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals
	
	Private ulvModUserList As UltimateListView
	Private clvPickList As CustomListView
	Private pnlPickList As Panel
	Private mblnCopyOnly As Boolean
	Dim mlstList As List
	Dim mlstPicked As List
	Dim mmlr As MainListRow 
	Private mblnUpdating As Boolean
	
End Sub

Sub Activity_Create(FirstTime As Boolean)

	' Only seems to show 3 buttons
	Activity.AddMenuItem3("Del selected items", "mnuDelete", LoadBitmap(File.DirAssets, "ic_menu_delete.png"), True)
	Activity.AddMenuItem3("Copy selected items to another list", "mnuCopy", LoadBitmap(File.DirAssets, "ic_menu_copy.png"), True)
	Activity.AddMenuItem3("Move selected items to another list", "mnuMove", LoadBitmap(File.DirAssets, "ic_menu_cut.png"), True)

End Sub

Sub Activity_Resume

	LoadList
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)

	If ulvModUserList.IsDragStarted Then
		ulvModUserList.CancelDrag
	End If

End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	
	' Reminder bits
	If KeyCode = KeyCodes.KEYCODE_BACK Then
		If DismissPanels Then
			Return True
		End If
	End If
	Return False
	
End Sub

Sub LoadList
	
	Dim intCnt1 As Int
	
	If Main.glstSelectedLists.Size > 1 Then
		Activity.Finish
	Else
		mmlr = Main.glstSelectedLists.Get(0)
		Activity.Title = mmlr.ListAbbr
		Activity.LoadLayout("moduserlist")
	End If

	ulvModUserList.AddRowLayout("LISTROW", "Item_RowLayoutCreator", "Item_RowContentFiller", 40dip, 3, Array As Int(35dip, 100%x-85dip, 50dip), 0dip, Colors.White, True)
	
	mlstList = File.ReadList(Starter.gstrDir, Module1.ListFilename(mmlr.ListName))

	ulvModUserList.ClearContent 
	For intCnt1 = 0 To mlstList.Size-1
		ulvModUserList.AddItem("LISTROW", intCnt1)
	Next
	
End Sub

Sub Item_RowLayoutCreator(LayoutName As String, CellPanel As Panel, CellIndex As Byte)
	
	Select Case CellIndex
	Case 0
		Dim chk As CheckBox
		chk.Initialize("ItemChk")
		CellPanel.AddView(chk, 0, 0, CellPanel.Width, CellPanel.Height)

		Dim pnl As B4XView
		Dim xui As XUI
		pnl = xui.CreatePanel("")
		pnl.SetColorAndBorder(Colors.Transparent, 1dip, LibConv.lib_GetColorIntFromHex("#FFD9D7DE"), 0)
		CellPanel.AddView(pnl, 0, 0, CellPanel.Width, 2dip)
	Case 1
		Dim lbl As Label
		lbl.Initialize("")
		lbl.Color = Colors.Transparent
		lbl.TextColor = Colors.RGB(mmlr.R, mmlr.G, mmlr.B)
		lbl.TextSize = 17
		lbl.Gravity = Gravity.CENTER_VERTICAL
		CellPanel.AddView(lbl, 0, 0, CellPanel.Width, CellPanel.Height)

		' ULV Divider is same colour as bg. I want white bg so adding panel where we can set border color.
		Dim pnl As B4XView
		Dim xui As XUI
		pnl = xui.CreatePanel("")
		pnl.SetColorAndBorder(Colors.Transparent, 1dip, LibConv.lib_GetColorIntFromHex("#FFD9D7DE"), 0)
		CellPanel.AddView(pnl, 0, 0, CellPanel.Width, 2dip)
	Case 2
		Dim lbl As Label
		lbl.Initialize("")
		'lbl.Color = Colors.Gray
		'lbl.TextColor = Colors.Black
		'lbl.TextSize = 14
		lbl.SetBackgroundImage(LoadBitmap(File.DirAssets, "scrollbar_handle_accelerated_anim2.9.png"))
		'lbl.Gravity = Gravity.CENTER_VERTICAL + Gravity.CENTER_HORIZONTAL
		CellPanel.AddView(lbl, 1dip, 1dip, CellPanel.Width-2dip, CellPanel.Height-2dip)
'		Dim btn As Button
'		btn.Initialize("ItemBtn")
'		btn.Color = Colors.Gray
'		btn.TextColor = Colors.Black
'		btn.Padding = Array As Int(5,5,5,5)
'		CellPanel.AddView(btn, 1dip, 1dip, CellPanel.Width-2dip, CellPanel.Height-2dip)

		Dim pnl As B4XView
		Dim xui As XUI
		pnl = xui.CreatePanel("")
		pnl.SetColorAndBorder(Colors.Transparent, 1dip, LibConv.lib_GetColorIntFromHex("#FFD9D7DE"), 0)
		CellPanel.AddView(pnl, 0, 0, CellPanel.Width, 2dip)
	End Select

End Sub

Sub Item_RowContentFiller(RowID As Long, LayoutName As String, CellPanel As Panel, CellIndex As Byte, Position As Int)

	Select Case CellIndex
	Case 0
		Dim chk As CheckBox = CellPanel.GetView(0)
		mblnUpdating = True
		chk.Checked = ulvModUserList.IsSelected(Position)
		mblnUpdating = False
	Case 1
		Dim lbl As Label = CellPanel.GetView(0)
		lbl.Text = mlstList.Get(RowID)

		' Grey picked items from lists that don't remove picked items
		' Done in RowContentFiller instead of RowLayoutCreator as grey is based on item name which isn't available there
		If Not(mmlr.DelSrcWhenPicked) Then
			mlstPicked = File.ReadList(Starter.gstrDir, Module1.PickedFilename(mmlr.ListName))
			If mlstPicked.IndexOf(lbl.Text) >= 0 Then
				lbl.TextColor = Colors.RGB(192,192,192)	'silver
			End If
		End If
'	Case 2
	End Select

End Sub

Private Sub ItemChk_CheckedChange(Checked As Boolean)
	
	If Not(mblnUpdating) Then
		ulvModUserList.SetSelected(ulvModUserList.GetPositionForID(ulvModUserList.FindIDInVisibleItems(Sender), True), Checked)
	End If
	
End Sub

Private Sub ulvModUserList_CellClick(RowID As Long, CellIndex As Byte, Position As Int, ClickedPanel As Panel)
	'Log("ulvModUserList_CellClick: RowID=" & RowID & ",CellIndex=" & CellIndex)
	
	Select Case CellIndex
	'Case 0
		'don't need this as clicking row calls Item_RowLayoutCreator which sets checkbox
	'Case 1
	'Case 2
	End Select
	
End Sub

Private Sub ulvModUserList_CellLongClick(RowID As Long, CellIndex As Byte, Position As Int, ClickedPanel As Panel)
	
	Select Case CellIndex
	'Case 0
	Case 1	'Rename
		Dim lbl As Label = ClickedPanel.GetView(0)
		If Not(lbl.Text.Contains(Chr(127))) Then
			Dim strNewName As String
			Dim mlr As MainListRow = Main.glstSelectedLists.Get(0)
			strNewName = Module1.RenameItem(mlr, lbl.Text, mlr.ListNo)
			If strNewName <> "" Then
				' Refresh module level list (updated by RenameItem)
				mlstList = File.ReadList(Starter.gstrDir, Module1.ListFilename(mmlr.ListName))
				ulvModUserList.RefreshContent
			End If
		End If		
	Case 2
		ulvModUserList.StartDrag(Position, True, Null)
	End Select
	
End Sub

Sub ulvModUserList_Dropped(DropView As View, StartPosition As Int, DropPosition As Int)

	Dim lst As List

	lst.Initialize 

	' Move item in underlying list
	' ULV doesn't seem to let me just read the whole list and write in that order to disk
	lst = File.ReadList(Starter.gstrDir, Module1.ListFilename(mmlr.ListName))		'can't use mlstList to do with index/order
	If DropPosition < StartPosition Then
		lst.InsertAt(DropPosition, lst.Get(StartPosition))
		lst.RemoveAt(StartPosition+1)
	else If DropPosition > StartPosition Then
		If DropPosition = ulvModUserList.NumberOfItems-1 Then
			lst.Add(lst.Get(StartPosition))
			lst.RemoveAt(StartPosition)
		Else
			lst.InsertAt(DropPosition+1, lst.Get(StartPosition))
			lst.RemoveAt(StartPosition)
		End If
	Else
		Return
	End If
	File.WriteList(Starter.gstrDir, Module1.ListFilename(mmlr.ListName), lst)
	ulvModUserList.RefreshContent
	
End Sub

Sub clvPickList_ItemClick (Index As Int, Value As Object)

	Dim lstSrc As List
	Dim lstTgt As List
	Dim lstSelecteds As List = ulvModUserList.GetSelectedIDs
	Dim strItem As String
	Dim mlrTgt As MainListRow
	Dim strExtraFileSrc As String
	Dim strExtraFileTgt As String
	Dim intCnt1 As Int
	
	pnlPickList.Visible = False
	If lstSelecteds.Size < 1 Then
		Return
	End If	

	' List might have been drag/dropped order changed. That updates underlying list without running LoadList, so now underlying list order
	' is same as current Position but RowID is outdated. So first update selectedIDs.
	For intCnt1 = 0 To lstSelecteds.Size-1
		lstSelecteds.Set(intCnt1, ulvModUserList.GetPositionForID(lstSelecteds.Get(intCnt1),False))
	Next
	lstSelecteds.Sort(False)
	
	lstSrc = File.ReadList(Starter.gstrDir, Module1.ListFilename(mmlr.ListName))
	lstTgt = File.ReadList(Starter.gstrDir, Module1.ListFilename(Value))
	For intCnt1 = 0 To lstSelecteds.Size-1
		strItem = lstSrc.Get(lstSelecteds.Get(intCnt1))
		If lstTgt.IndexOf(strItem) >= 0 Then
			MsgboxAsync(strItem & " already exists in " & Value, "")
			Wait For Msgbox_Result
		Else
			lstTgt.InsertAt(0, strItem)
			If Not(mblnCopyOnly) Then
				'lstSrc.RemoveAt(lstSrc.IndexOf(strItem))
				lstSrc.RemoveAt(lstSelecteds.Get(intCnt1))
			End If
			' Copy/move extra file
			strExtraFileSrc = Module1.ExtraFilename(mmlr.ListNo, strItem)
			mlrTgt = Module1.MainListRow_FromListName(Value)
			strExtraFileTgt = Module1.ExtraFilename(mlrTgt.ListNo, strItem)
			If File.Exists(Starter.gstrDir, strExtraFileSrc) Then
				If File.Exists(Starter.gstrDir, strExtraFileTgt) Then
					File.Delete(Starter.gstrDir, strExtraFileTgt) 		'if here, item didn't exist in tgt so extra shouldnt exist either
				End If
				If mblnCopyOnly Then
					File.Copy(Starter.gstrDir, strExtraFileSrc, Starter.gstrDir, strExtraFileTgt)
				Else
					LibGen.lib_RenameFile(Starter.gstrDir, strExtraFileSrc, strExtraFileTgt)
				End If
			End If
		End If
	Next
	File.WriteList(Starter.gstrDir, Module1.ListFilename(mmlr.ListName), lstSrc)
	File.WriteList(Starter.gstrDir, Module1.ListFilename(Value), lstTgt)

	'If Not(mblnCopyOnly) Then
		LoadList
	'End If
	
End Sub
'
' Rtn whether any panel was visible/dismissed
'
Sub DismissPanels As Boolean
	
	Dim blnRtn As Boolean

	If pnlPickList.Visible Then
		pnlPickList.Visible = False
		blnRtn = True
	End If
	Return blnRtn
	
End Sub
'
' Load list of other Lists to copy/move to
'
Sub LoadMenuCopyMoveItems

	Dim strLine As String
	Dim lstMain As List = File.ReadList(Starter.gstrDir, Main.gstrMainList)
	Dim mlr As MainListRow

	clvPickList.Clear
	For intCnt1 = 0 To lstMain.Size-1
		strLine = lstMain.Get(intCnt1)
		mlr = Module1.ConvertStringToType_MainListRow(strLine)
		If mlr.ListNo <> mmlr.ListNo Then
			clvPickList.AddTextItem(mlr.ListName, mlr.ListName)
		End If
	Next
	If clvPickList.GetSize > 0 Then
		pnlPickList.Visible = True
	End If
	
End Sub

Sub mnuCopy_Click

	mblnCopyOnly = True
	LoadMenuCopyMoveItems
	
End Sub

Sub mnuDelete_Click

	Dim lstSelecteds As List = ulvModUserList.GetSelectedIDs
	Dim strExtraFileSrc As String
	Dim intCnt1 As Int
	
	pnlPickList.Visible = False
	If lstSelecteds.Size < 1 Then
		Return
	End If
	
	' List might have been drag/dropped order changed. That updates underlying list without running LoadList, so now underlying list order
	' is same as current Position but RowID is outdated. So first update selectedIDs.
	For intCnt1 = 0 To lstSelecteds.Size-1
		lstSelecteds.Set(intCnt1, ulvModUserList.GetPositionForID(lstSelecteds.Get(intCnt1),False ) )
	Next
	lstSelecteds.Sort(False)
	
	For intCnt1 = 0 To lstSelecteds.Size-1
		' Del extra file
		strExtraFileSrc = Module1.ExtraFilename(mmlr.ListNo, mlstList.Get(lstSelecteds.Get(intCnt1)))
		If File.Exists(Starter.gstrDir, strExtraFileSrc) Then
			File.Delete(Starter.gstrDir, strExtraFileSrc) 
		End If
		mlstList.RemoveAt(lstSelecteds.Get(intCnt1))
	Next
	File.WriteList(Starter.gstrDir, Module1.ListFilename(mmlr.ListName), mlstList)

	LoadList
	
End Sub

Sub mnuMove_Click

	mblnCopyOnly = False
	LoadMenuCopyMoveItems
	
End Sub



