﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.5
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub
'
' Some text mucks up reading into lists etc
'
Sub CleanItemName(pstrItem As String) As String

	Return pstrItem.Replace(",", " ").Replace("  ", " ")
	
End Sub

Sub ConvertTypeToString_MainListRow(pmlr As MainListRow) As String

	Return pmlr.ListNo & "," & pmlr.ListName & "," & pmlr.ListAbbr & "," & pmlr.DelSrcWhenPicked & "," & pmlr.MasterList & "," _
	  & pmlr.R & "," & pmlr.G & "," & pmlr.B & "," & pmlr.HighlightCnt & "," & pmlr.MasterKbd  & "," & pmlr.MasterImm
	
End Sub

Sub ConvertStringToType_MainListRow(pstr As String) As MainListRow
	
	Dim strParts() As String
	Dim mlr As MainListRow
	
	strParts = Regex.Split(",", pstr)
	mlr.Initialize
	mlr.ListNo = strParts(0)
	mlr.ListName = strParts(1)
	mlr.ListAbbr = strParts(2)
	mlr.DelSrcWhenPicked = LibConv.lib_Cbool(strParts(3))
	mlr.MasterList = strParts(4)
	mlr.R = strParts(5)
	mlr.G = strParts(6)
	mlr.B = strParts(7)
	mlr.HighlightCnt = LibConv.lib_Cbool(strParts(8))
	mlr.MasterKbd = LibConv.lib_Cbool(strParts(9))
	mlr.MasterImm = LibConv.lib_Cbool(strParts(10))
	Return mlr
	
End Sub

Sub ExtraFilename(pstrListNo As String, pstrItem As String) As String
	
	Return "Extra_" & pstrListNo & "_" & LibConv.lib_ReplInvalidChars_Filename(pstrItem, "") & ".txt"
	
End Sub
'
' Call this to create valid filename for a ListName or a MasterList name
'
Sub ListFilename(pstrListName As String) As String
	
	Return LibConv.lib_ReplInvalidChars_Filename(pstrListName, "") & ".txt"
	
End Sub

Sub PickedFilename(pstrListName As String) As String
	
	Return LibConv.lib_ReplInvalidChars_Filename(pstrListName, "") & "_picked.txt"
	
End Sub

Sub MainListRow_FromListName(pstrName As String) As MainListRow
	
	Dim lstMain As List = File.ReadList(Starter.gstrDir, Main.gstrMainList)
	Dim intCnt1 As Int
	Dim mlr As MainListRow
	
	For intCnt1 = 0 To lstMain.Size-1
		mlr = ConvertStringToType_MainListRow(lstMain.Get(intCnt1))
		If mlr.ListName = pstrName Then
			Return mlr
		End If
	Next
	
End Sub

Sub MainListRow_FromListNo(pintListNo As Int) As MainListRow
	
	Dim lstMain As List = File.ReadList(Starter.gstrDir, Main.gstrMainList)
	Dim intCnt1 As Int
	Dim mlr As MainListRow
	
	For intCnt1 = 0 To lstMain.Size-1
		mlr = ConvertStringToType_MainListRow(lstMain.Get(intCnt1))
		If mlr.ListNo = pintListNo Then 
			Return mlr
		End If
	Next
	
End Sub
'
' pThisListNo may not be same as pmlr.ListNo (source listno) if item is linked
'
Sub RenameItem(pmlrSrc As MainListRow, pstrItem As String, pThisListNo As Int) As String
	
	Dim intIndex As Int
	Dim intInsertAt As Int
	Dim intLoc As Int
	Dim strFile As String
	Dim lstSrc As List
	Dim lstPicked As List
	Dim lstThis As List 
	Dim mlr As MainListRow
	Dim mlrThis As MainListRow
	Dim inpNewText As InputDialog		'rtns -1=posbtn, -2=negbtn, -3=canbtn or back  : Lib:Dialogs
	Dim strInput As String
	Dim strLookFor As String
	
	inpNewText.Input = pstrItem
	If inpNewText.Show("", "", "Ok", "", "", Null) = DialogResponse.POSITIVE Then
		strInput = CleanItemName(inpNewText.Input)
		If strInput = "" Or strInput = pstrItem Then
			Return ""
		End If
	Else
		Return ""
	End If

	' Rename in this list
	lstSrc = File.ReadList(Starter.gstrDir, ListFilename(pmlrSrc.ListName))
	mlrThis = MainListRow_FromListNo(pThisListNo)
	lstThis = File.ReadList(Starter.gstrDir, ListFilename(mlrThis.ListName))			
	intLoc = strInput.LastIndexOf("..")			'can end .. or ..1|2 etc
	If intLoc > 0 Then	'And intLoc < strItem.Length-2 Then
		If intLoc = strInput.Length-2 Then
			intInsertAt = 999
			strInput = strInput.SubString2(0, intLoc)
		Else
			If IsNumber(strInput.SubString(intLoc+2)) Then
				intInsertAt = strInput.SubString(intLoc+2)
				If intInsertAt < 0 Then
					intInsertAt = 1
				else if intInsertAt > lstThis.Size Then
					intInsertAt = 999
				End If
				strInput = strInput.SubString2(0, intLoc)
			End If
		End If

		' Move existing item
		If pThisListNo <> pmlrSrc.ListNo Then
			' Move within this list, not src
			intIndex = lstThis.IndexOf(pstrItem & Chr(127) & pmlrSrc.ListNo)
			lstThis.RemoveAt(intIndex)
			If intInsertAt = 999 Then
				lstThis.Add(strInput & Chr(127) & pmlrSrc.ListNo)
			Else
				lstThis.InsertAt(intInsertAt-1, strInput & Chr(127) & pmlrSrc.ListNo)
			End If
			File.WriteList(Starter.gstrDir, ListFilename(mlrThis.ListName), lstThis)
			' Check if name changed also, in which case rename in source list
			If strInput <> pstrItem Then
				intIndex = lstSrc.IndexOf(pstrItem)
				lstSrc.Set(intIndex, strInput)		
				File.WriteList(Starter.gstrDir, ListFilename(pmlrSrc.ListName), lstSrc)				
			End If
		Else
			intIndex = lstSrc.IndexOf(pstrItem)
			lstSrc.RemoveAt(intIndex)
			If intInsertAt = 999 Then
				lstSrc.Add(strInput)
			Else
				lstSrc.InsertAt(intInsertAt-1, strInput)
			End If
			File.WriteList(Starter.gstrDir, ListFilename(pmlrSrc.ListName), lstSrc)
		End If
	Else
		intIndex = lstSrc.IndexOf(pstrItem)
		lstSrc.Set(intIndex, strInput)		
		File.WriteList(Starter.gstrDir, ListFilename(pmlrSrc.ListName), lstSrc)
	End If	

	' Rename in picked list
	lstPicked = File.ReadList(Starter.gstrDir, PickedFilename(pmlrSrc.ListName))
	If lstPicked.IndexOf(pstrItem) >= 0 Then
		lstPicked.RemoveAt(lstPicked.IndexOf(pstrItem))
		lstPicked.Add(strInput)
		File.WriteList(Starter.gstrDir, PickedFilename(pmlrSrc.ListName), lstPicked)
	End If
	
	' Rename if exists as linked item in any other list
	If strInput <> pstrItem Then
		strLookFor = pstrItem & Chr(127) & pmlrSrc.ListNo
		For intCnt1 = 0 To Main.glstAllLists.Size-1
			If intCnt1 <> pmlrSrc.ListNo Then
				mlr = Main.glstAllLists.Get(intCnt1)
				If mlr.ListName <> Null Then
					lstSrc = File.ReadList(Starter.gstrDir, ListFilename(mlr.ListName))
					intIndex = lstSrc.IndexOf(strLookFor)
					If intIndex >=0 Then
						lstSrc.Set(intIndex, strInput & Chr(127) & pmlrSrc.ListNo)
						File.WriteList(Starter.gstrDir, ListFilename(mlr.ListName), lstSrc)
					End If
				End If
			End If
		Next
	End If
	
	' Rename extra
	strFile = ExtraFilename(pmlrSrc.ListNo, pstrItem)
	If File.Exists(Starter.gstrDir, strFile) Then
		LibGen.lib_RenameFile(Starter.gstrDir, strFile, ExtraFilename(pmlrSrc.ListNo, strInput))
	End If

	Return strInput
	
End Sub

'
' Remove any items found in picked from src list (typ As changed DelSrcWhenPicked)
'
Sub RemoveAllPickedItems(pmlr As MainListRow)

	Dim intCnt1 As Int 
	Dim lstList As List = File.ReadList(Starter.gstrDir, ListFilename(pmlr.ListName))
	Dim lstPicked As List = File.ReadList(Starter.gstrDir, PickedFilename(pmlr.ListName))
	
	For intCnt1 = lstPicked.Size-1 To 0 Step -1
		If lstList.IndexOf(lstPicked.Get(intCnt1)) >=0 Then		'it should be
			lstList.RemoveAt(lstList.IndexOf(lstPicked.Get(intCnt1)))
		End If
		lstPicked.RemoveAt(intCnt1)
	Next
	
	File.WriteList(Starter.gstrDir, ListFilename(pmlr.ListName), lstList)
	File.WriteList(Starter.gstrDir, PickedFilename(pmlr.ListName), lstPicked)
		
End Sub