﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
'Reqs any project to link cls ContactUtils, libs ContentResolver, SQL
'
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub lib_GetContactByPhno(pstrPhno As String, pblnFirstnameOnly As Boolean) As String

	Dim cu As ContactsUtils	
	Dim listContacts As List
	Dim listPhoneNos As List
	Dim intCnt1 As Int
	Dim intCnt2 As Int
	Dim strParts() As String
	Dim strPhno As String
	Dim strName As String
	
	cu.Initialize
	pstrPhno = LibConv.lib_CleanPhNo(pstrPhno)
	'Log(pstrPhno)
	'Log(pstrPhno.Substring(pstrPhno.Length - 4))
	If pstrPhno.Length > 7 Then
		' Start with list of phnos that end the same. Then clean these up and look for exact match.
		listContacts = cu.FindContactsByPhone(pstrPhno.Substring(pstrPhno.Length - 4), False, False)	'VisibleOnly shows whatever is defined in your Custom contacts view on the phone
		LibGen.lib_DebugLog("MatchingContacts=" & listContacts.Size, True)
		For intCnt1 = 0 To listContacts.Size-1
			'LibGen.lib_DebugLog(listContacts.Get(intCnt1), True)
			Dim c As cuContact = listContacts.Get(intCnt1)
			strName = c.DisplayName
			listPhoneNos = cu.GetPhones(c.Id)
			LibGen.lib_DebugLog("ContactPhoneNosAvail=" & listPhoneNos.Size, True)
			For intCnt2=0 To listPhoneNos.Size-1
				'LibGen.lib_DebugLog(intCnt2 & ":" & listPhoneNos.Get(intCnt2), True)
				Dim p As cuPhone = listPhoneNos.Get(intCnt2)
				strPhno = LibConv.lib_CleanPhNo(p.Number)
				'LibGen.lib_DebugLog("Match=" & (strPhno=pstrPhno), True)
				If strPhno = pstrPhno Then
					If pblnFirstnameOnly Then
						strParts = Regex.Split(" ", strName)
						Return strParts(0)
					Else
						Return strName
					End If
				End If
			Next
		Next
	End If
	Return ""
	
End Sub
'
' Pass Id of contact
' Looks for Work_Mobile if exists else Mobile
Sub lib_GetMobileNo(pContactId As Long) As String

	Dim cu As ContactsUtils		
	Dim lstPhoneNos As List
	Dim intCnt1 As Int 
	Dim c As cuPhone 
	Dim strPhoneNo As String

	cu.Initialize 
	lstPhoneNos = cu.GetPhones(pContactId)
	For intCnt1 = 0 To lstPhoneNos.Size-1
		c = lstPhoneNos.Get(intCnt1)
		If c.PhoneType = "work_mobile" Then
			Return c.Number
		else If c.PhoneType = "mobile" Then
			strPhoneNo = c.Number			
		End If
	Next
	Return strPhoneNo
	
End Sub

Sub lib_ListAllContacts(pstOptLogToDir As String, pstOptLogToFile As String, plblMsg As Label)

	Dim cu As ContactsUtils	
	Dim listContacts As List
	Dim listDetails As List
	Dim listOutput As List
	Dim blnAcctFnd As Boolean
	Dim intCnt1 As Int
	Dim intCnt2 As Int
	Dim intCnt3 As Int
	Dim intPhNosCnt As Int
	Dim intEmailsCnt As Int
	Dim intAcctsCnt As Int
	Dim intMaxAcctsCnt As Int
	Dim intTotAcctsCnt(20) As Int
	Dim strPhNos As String
	Dim strPhNosCleaned As String
	Dim strEmails As String
	Dim strFirstGmail As String
	Dim strAccount As String
	Dim strName As String
	Dim strAccounts(20) As String
	Dim strAccountTypes(20) As String
	Dim mapAccounts As Map
	Dim strLogline As String
	
	cu.Initialize
	listContacts = cu.FindAllContacts(False)		'VisibleOnly shows whatever is defined in your Custom contacts view on the phone
	Log("ContactsCnt=" & listContacts.Size)
	intMaxAcctsCnt = 4
	strAccountTypes(0) = "Phone"
	strAccountTypes(1) = "Sim"
	strAccountTypes(2) = "Whatsapp"
	strAccountTypes(3) = "Gmail"

	listOutput.Initialize
	Dim intContactsCnt As Int = listContacts.Size-1
	For intCnt1 = 0 To intContactsCnt
		If intCnt1 Mod 50 = 0 Then
			plblMsg.Text = "Reading " & intContactsCnt & " contacts..." & intCnt1
			DoEvents	'supposed to use sleep(0) but get very diff result, doevents will do for this app
		End If
		strPhNos = ""
		strPhNosCleaned = ""
		strEmails = ""
		Dim c As cuContact = listContacts.Get(intCnt1)
		strName = c.DisplayName

		listDetails = cu.GetPhones(c.Id)
		intPhNosCnt = listDetails.Size
		For intCnt2 = 0 To listDetails.Size-1
			Dim p As cuPhone = listDetails.Get(intCnt2)
			If intCnt2 > 0 Then
				strPhNos = strPhNos & ";"
				strPhNosCleaned = strPhNosCleaned & ";"
			End If
			strPhNos = strPhNos & p.Number
			strPhNosCleaned = strPhNosCleaned & LibConv.lib_CleanPhNo(p.Number)
		Next

		listDetails = cu.GetEmails(c.Id)
		intEmailsCnt = listDetails.Size
		For intCnt2 = 0 To listDetails.Size-1
			Dim e As cuEmail = listDetails.Get(intCnt2)
			If intCnt2 > 0 Then
				strEmails = strEmails & ";"
			End If
			strEmails = strEmails & e.Email
		Next

		For intCnt2 = 0 To intMaxAcctsCnt-1: strAccounts(intCnt2) = "": Next
		mapAccounts = cu.GetAccounts(c.Id)
		intAcctsCnt = mapAccounts.Size
		For intCnt2 = 0 To intAcctsCnt-1
			strAccount = ""
			blnAcctFnd = True
			Select Case mapAccounts.GetValueAt(intCnt2)
				Case "vnd.sec.contact.phone"
					strAccounts(0) = "Phone"
					intTotAcctsCnt(0) = intTotAcctsCnt(0) + 1
				Case "vnd.sec.contact.sim"
					strAccounts(1) = "Sim"
					intTotAcctsCnt(1) = intTotAcctsCnt(1) + 1
				Case "com.whatsapp"
					strAccounts(2) = "Whatsapp"
					intTotAcctsCnt(2) = intTotAcctsCnt(2) + 1
                Case "com.google"		'if only 1 gmail turns up, mark related as Gmail. any others in col or their own by full gmail name
					If strFirstGmail = "" Then
						strAccounts(3) = "Gmail"
						strFirstGmail = mapAccounts.GetKeyAt(intCnt2)
					Else
						If mapAccounts.GetKeyAt(intCnt2) = strFirstGmail Then
							strAccounts(3) = "Gmail"
							intTotAcctsCnt(3) = intTotAcctsCnt(3) + 1
						Else
							strAccount = mapAccounts.GetKeyAt(intCnt2)
							blnAcctFnd = False
						End If
					End If
				Case Else
					strAccount = mapAccounts.GetValueAt(intCnt2)
					blnAcctFnd = False
            End Select
				
			If Not(blnAcctFnd) Then					
				For intCnt3 = 4 To intMaxAcctsCnt-1
					If strAccount = strAccountTypes(intCnt3) Then
						blnAcctFnd = True
						intTotAcctsCnt(intCnt3) = intTotAcctsCnt(intCnt3) + 1
						strAccounts(intCnt3) = strAccount
						Exit
					End If
				Next
				If Not(blnAcctFnd) Then
					intMaxAcctsCnt = intMaxAcctsCnt + 1
					strAccountTypes(intMaxAcctsCnt-1) = strAccount
					intTotAcctsCnt(intMaxAcctsCnt-1) = 1
					strAccounts(intMaxAcctsCnt-1) = strAccountTypes(intMaxAcctsCnt-1)
				End If
			End If
		Next
		strLogline = strName.Replace(",",";") & "," & intPhNosCnt  & "," & strPhNos & "," & strPhNosCleaned & "," & intEmailsCnt & "," & strEmails & "," & intAcctsCnt
		For intCnt2 = 0 To intMaxAcctsCnt-1
			strLogline = strLogline & "," & strAccounts(intCnt2)
		Next
		listOutput.Add(strLogline)
	Next

	listOutput.SortCaseInsensitive(True)
	For intCnt1 = 0 To listContacts.Size-1
		Log(listOutput.Get(intCnt1))
	Next
	If pstOptLogToFile <> "" Then
		If File.Exists(pstOptLogToDir, pstOptLogToFile) Then
			File.Delete(pstOptLogToDir, pstOptLogToFile)
		End If
		strLogline = "Name(" & listContacts.Size & "),PhNosCnt,PhNos,PhNosCleaned,EmailsCnt,Emails,AcctsCnt"
		For intCnt2 = 0 To intMaxAcctsCnt-1
			strLogline = strLogline & "," & strAccountTypes(intCnt2) & "(" & intTotAcctsCnt(intCnt2) & ")"
		Next
		listOutput.InsertAt(0, strLogline)
		File.WriteList(pstOptLogToDir, pstOptLogToFile, listOutput)
	End If

	'If pblnShowProgressDlg Then
	'	ProgressDialogHide
	'End If
	
End Sub