﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
'Reqs any project to link libs DateUtils

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	'Dim gTst As Double
End Sub

Sub lib_Cbool(pstrVal As String) As Boolean

	If IsNumber(pstrVal) Then
		Return pstrVal	
	Else
		Select Case pstrVal.ToLowerCase
			Case "true"
				Return True
			Case "False"
				Return False
			Case Else
				Return False
		End Select
	End If
End Sub

Sub lib_CleanPhNo(pstrPhno As String) As String
	
	'LibGen.lib_DebugLog("Clean1:" & pstrPhno, True)
	If pstrPhno.StartsWith("+") Then
		pstrPhno = "0" & pstrPhno.SubString(3)
		'LibGen.lib_DebugLog("Clean2:" & pstrPhno, True)
	End If
	pstrPhno = pstrPhno.Replace("-","")
	pstrPhno = pstrPhno.Replace(" ","")
	'LibGen.lib_DebugLog("Clean3:" & pstrPhno, True)
	Return pstrPhno
	
End Sub
'
' Convert abs(diff) between given date & now into years/mths/days
' If years or mths = 0 they won't be included in results
'
Sub lib_ConvertDateDiffToYMD(pdt As Long, pstrYearsSuffix As String, pstrMthsSuffix As String, pstrDaysSuffix As String) As String
	
	Dim intDays As Int 
	Dim intMths As Int
	Dim intYears As Int
	Dim dtEarliest As Long
	Dim dtLatest As Long
	Dim dt As Long
	Dim strRtn As String
	
	'Log(DateTime.Date(DateTime.Now))
	'Log(DateTime.Date(pdt))
	'Log(DateTime.Date(pdt-DateTime.Now) & " " & DateTime.Time(pdt-DateTime.Now))
	If pdt <= DateTime.Now Then
		' Date is in past
		dtEarliest = lib_DateFromDatetime(pdt)
		dtLatest = lib_DateFromDatetime(DateTime.Now)
	Else
		' Date is in future
		dtEarliest = lib_DateFromDatetime(DateTime.Now)
		dtLatest = lib_DateFromDatetime(pdt)
	End If
	
	dt = DateTime.Add(dtLatest, -1, 0, 0) 
	Do While dt >= dtEarliest
		intYears = intYears + 1
		dt = DateTime.Add(dt, -1, 0, 0) 
	Loop
	dt = DateTime.Add(dtLatest, -intYears, -1, 0) 
	Do While dt >= dtEarliest
		intMths = intMths + 1
		dt = DateTime.Add(dt, 0, -1, 0) 
	Loop
	dt = DateTime.Add(dtLatest, -intYears, -intMths, -1) 
	Do While dt >= dtEarliest
		intDays = intDays + 1
		dt = DateTime.Add(dt, 0, 0, -1) 
	Loop
	'Log(intYears & "," & intMths & "," & intDays)
	If intYears > 0 Then
		strRtn = intYears & pstrYearsSuffix
	End If
	If intMths > 0 Then
		strRtn = strRtn & intMths & pstrMthsSuffix
	End If
	If intDays > 0 Then
		strRtn = strRtn & intDays & pstrDaysSuffix
	End If
	Return strRtn	
	
End Sub
'
' Convert a number of minutes into [x days,][x hours,][x minutes]
'
Sub lib_ConvertMinutesToWords(pintMinutes As Long, pblnDaysAsHours As Boolean) As String

	Dim intMins As Int
	Dim intHours As Int
	Dim intDays As Int
	Dim strText As String

	intHours = pintMinutes/60
	intMins = pintMinutes - intHours*60
	If Not(pblnDaysAsHours) Then
		intDays = intHours/24 
		If intDays = 1 Then
			strText = "1 day"
		Else
			strText = intDays & " days"
		End If
		intHours = intHours - intDays*24
	End If
	If intHours > 0 Then
		If strText <> "" Then
			strText = strText & ", "
		End If
		If intHours = 1 Then
			strText = strText & "1 hour"
		Else
			strText = strText & intHours & " hours"
		End If
	End If
	If intMins > 0 Or (intHours = 0 And strText = "") Then
		If strText <> "" Then
			strText = strText & ", "
		End If
		If intMins = 1 Then
			strText = strText & "1 minute"
		Else
			strText = strText & intMins & " minutes"
		End If
	End If
	Return strText
	
End Sub
'
' Convert abs(diff) between given date & now into [x days,][x hours,][x minutes]
'
Sub lib_ConvertTimeDiffToWords(pdt As Long, pblnDaysAsHours As Boolean) As String

	Dim prdDateDiff As Period
	Dim intMins As Int
	Dim intHours As Int
	Dim strText As String
	Dim dtEarliest As Long
	Dim dtLatest As Long
	
	If pdt <= DateTime.Now Then
		' Date is in past
		dtEarliest = pdt
		dtLatest = DateTime.Now
	Else
		' Date is in future
		dtEarliest = DateTime.Now
		dtLatest = pdt
	End If
	prdDateDiff = DateUtils.PeriodBetween(dtEarliest, dtLatest)
	' We round to whole minutes
	If pblnDaysAsHours Then
		intHours = prdDateDiff.Days*24
	Else
		If prdDateDiff.Days = 1 Then
			strText = "1 day"
		Else
			strText = prdDateDiff.Days & " days"
		End If
	End If
	intHours = intHours + prdDateDiff.Hours
	intMins = prdDateDiff.Minutes + Round(prdDateDiff.Seconds/60)
	If intMins = 60 Then	'can happen when round secs
		intHours = intHours + 1
		intMins = 0
	End If
	If intHours > 0 Then
		If strText <> "" Then
			strText = strText & ", "
		End If
		If intHours = 1 Then
			strText = strText & "1 hour"
		Else
			strText = strText & intHours & " hours"
		End If
	End If
	If intMins > 0 Or (intHours = 0 And strText = "") Then
		If strText <> "" Then
			strText = strText & ", "
		End If
		If intMins = 1 Then
			strText = strText & "1 minute"
		Else
			strText = strText & intMins & " minutes"
		End If
	End If
	Return strText
	
End Sub
'
' Convert abs(diff) between given date & now into [xd]hh:mm
'
Sub lib_ConvertTimeDiffToHHMM(pdt As Long, pblnDaysAsHours As Boolean, pblnDontShowZeroHours As Boolean) As String
	
	Dim prdDateDiff As Period
	Dim intMins As Int
	Dim intHours As Int
	Dim strText As String
	Dim dtEarliest As Long
	Dim dtLatest As Long
	
	If pdt <= DateTime.Now Then
		' Date is in past
		dtEarliest = pdt
		dtLatest = DateTime.Now
	Else
		' Date is in future
		dtEarliest = DateTime.Now
		dtLatest = pdt
	End If
	prdDateDiff = DateUtils.PeriodBetween(dtEarliest, dtLatest)
	' We round to whole minutes
	If pblnDaysAsHours Then
		intHours = prdDateDiff.Days*24
	Else
		strText = prdDateDiff.Days & "d"
	End If
	intHours = intHours + prdDateDiff.Hours
	intMins = prdDateDiff.Minutes + Round(prdDateDiff.Seconds/60)
	If intMins = 60 Then	'can happen when round secs
		intHours = intHours + 1
		intMins = 0
	End If
	If intHours > 0 Or strText <> "" Or Not(pblnDontShowZeroHours) Then
		If intHours < 10 Then
			strText = strText & "0"
		End If
		strText = strText & intHours & ":"
		If intMins < 10 Then
			strText = strText & "0"
		End If
		strText = strText & intMins
	Else
		' Will not have leading 0
		strText = strText & intMins		
	End If
	Return strText
	
End Sub
'
' Convert abs(diff) between given date & now into hh:mm:ss
'
Sub lib_ConvertTimeDiffToHHMMSS(pdt As Long, pblnDontShowZeroHours As Boolean, pblnDontShowZeroMins As Boolean) As String
	
	Dim prdDateDiff As Period
	Dim intMins As Int
	Dim intHours As Int
	Dim intSecs As Int 
	Dim dtEarliest As Long
	Dim dtLatest As Long

	'Log(DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now))
	'Log(DateTime.Date(pdt) & " " & DateTime.Time(pdt))
	'Log(DateTime.Date(pdt-DateTime.Now) & " " & DateTime.Time(pdt-DateTime.Now))
	If pdt <= DateTime.Now Then
		' Date is in past
		dtEarliest = pdt
		dtLatest = DateTime.Now
	Else
		' Date is in future
		dtEarliest = DateTime.Now
		dtLatest = pdt
	End If
	prdDateDiff = DateUtils.PeriodBetween(dtEarliest, dtLatest)
	intHours = prdDateDiff.Days*24
	intHours = intHours + prdDateDiff.Hours
	intMins = prdDateDiff.Minutes
	intSecs = prdDateDiff.Seconds													'9.99 secs is returned as 9
	'Log(intHours)
	'Log(intMins)
	'Log(intSecs)
	'gTst =	(dtLatest - dtEarliest)/1000 - intHours*3600 - intMins*60
	'Log((dtLatest - dtEarliest)/1000 - intHours*3600 - intMins*60)
	intSecs = Round((dtLatest - dtEarliest)/1000) - intHours*3600 - intMins*60		'9.99 secs is returned as 10
	'Log(intSecs)
	If intSecs = 60 Then	'can happen due to rounding
		intMins = intMins + 1
		intSecs = 0
		If intMins = 60 Then
			intHours = intHours + 1
			intMins = 0
		End If
	End If
	Return lib_FormatTimeHHMMSS(intHours, intMins, intSecs, pblnDontShowZeroHours, pblnDontShowZeroMins)
	
End Sub
'
' Convert words representing time (typically as spoken eg. two hous 10 minutes) into a number of minutes
' Use when want a reminder service etc to popup in x minutes
' Can pass through lib_ConvertMinutesToWords if want hours/minutes read back
' Will accept seconds also if spoken (expected for testing mostly)
' 
Sub lib_ConvertTimeWordsToMinutes(pstrTimeWords As String) As Float

	Dim intCnt1 As Int
	Dim intCnt2 As Int
	Dim intStartWords As Int = -1
	Dim sngMultiplier As Float
	Dim sngMinutes As Float
	Dim dtTime As Long
	Dim strParts() As String
	Dim strWords As String
	Dim prdDateDiff As Period
    
	strParts = Regex.Split(" ", pstrTimeWords.ToLowerCase)
	
	' Looks for keywords then pass all words before to lib_ConvertWordsToNumber
	' First, have we been given a specific time - keywords "[Time]/[At] hhmm"
	Select Case strParts(0)
		Case "time", "at"
			strWords = pstrTimeWords.SubString(strParts(0).Length+1).Replace(":","").ToLowerCase
			Try
				If strWords.SubString2(0, 2) < DateTime.GetHour(DateTime.Now) Or (strWords.SubString2(0, 2) = DateTime.GetHour(DateTime.Now) And strWords.SubString2(2, 4) < DateTime.GetMinute(DateTime.Now)+1) Then
					dtTime = DateUtils.SetDateAndTime(DateTime.GetYear(DateTime.Now), DateTime.GetMonth(DateTime.Now), DateTime.GetDayOfMonth(DateTime.Now)+1, strWords.SubString2(0, 2), strWords.SubString2(2, 4), 0)
				Else
					dtTime = DateUtils.SetDateAndTime(DateTime.GetYear(DateTime.Now), DateTime.GetMonth(DateTime.Now), DateTime.GetDayOfMonth(DateTime.Now), strWords.SubString2(0, 2), strWords.SubString2(2, 4), 0)
				End If
				'Log(DateTime.Date(dtTime) & " " & DateTime.Time(dtTime))
				prdDateDiff = DateUtils.PeriodBetween(DateTime.now, dtTime)
				sngMinutes = prdDateDiff.Days*24 + prdDateDiff.Hours*60 + prdDateDiff.Minutes + Round(prdDateDiff.Seconds/60)
			Catch
				Return 0
			End Try
		Case Else
			For intCnt1 = 0 To strParts.Length-1
				sngMultiplier = 0
				Select Case strParts(intCnt1)
					Case "days"
						sngMultiplier = 1440
					Case "hours", "hour"
						sngMultiplier = 60
					Case "minutes", "minute", "mins"
						sngMultiplier = 1
					Case "seconds"
						sngMultiplier = 1/60
				End Select
				If sngMultiplier > 0 Then
					strWords = ""
					For intCnt2 = intStartWords+1 To intCnt1-1
						strWords = strWords & " " & strParts(intCnt2)
					Next
					sngMinutes = sngMinutes + lib_ConvertWordsToNumber(strWords) * sngMultiplier
					intStartWords = intCnt1
				End If
			Next
	
			' Handle where the word 'minute/minutes' was not given  eg. forty (ie 40 mins)
			If intStartWords < strParts.Length-1 And sngMultiplier <> 1 Then
				strWords = ""
				For intCnt2 = intStartWords+1 To strParts.Length-1
					strWords = strWords & " " & strParts(intCnt2)
				Next
				sngMinutes = sngMinutes + lib_ConvertWordsToNumber(strWords)
			End If
	End Select
	
	Return sngMinutes
		
End Sub
'
' Convert written word form of a number (perhaps returned from TextToSpeech) into number
' Supports 0-9999
'
Sub lib_ConvertWordsToNumber(pstrWords As String) As Int
        
	Dim intCnt1 As Int
	Dim intPart As Int
	Dim intMultiplier As Int = 1
	Dim intNumber As Int
	Dim intDigit As Int
	Dim strParts() As String
    
	strParts = Regex.Split(" ", pstrWords.ToLowerCase)
	For intCnt1 = strParts.Length - 1 To 0 Step -1
		If strParts(intCnt1) <> "and" And strParts(intCnt1) <> "" Then
			intPart = intPart + 1
			If IsNumber(strParts(intCnt1)) Then
				intDigit = strParts(intCnt1)
				intNumber = intNumber + intDigit * intMultiplier
			Else
				Select Case intPart
					Case 1
						Select Case strParts(intCnt1)
							Case "zero", "nought", "o", "oh"
								Return 0
							Case "one", "wan"
								intNumber = 1
							Case "two", "to", "too"
								intNumber = 2
							Case "three"
								intNumber = 3
							Case "four", "for"
								intNumber = 4
							Case "five"
								intNumber = 5
							Case "six", "sex"
								intNumber = 6
							Case "seven"
								intNumber = 7
							Case "eight", "ate"
								intNumber = 8
							Case "nine", "nan", "naan"
								intNumber = 9
							Case "ten", "tan", "tin"
								intNumber = 10
							Case "eleven"
								intNumber = 11
							Case "twelve"
								intNumber = 12
							Case "thirteen"
								intNumber = 13
							Case "fourteen"
								intNumber = 14
							Case "fifteen"
								intNumber = 15
							Case "sixteen"
								intNumber = 16
							Case "seventeen"
								intNumber = 17
							Case "eighteen"
								intNumber = 18
							Case "nineteen"
								intNumber = 19
							Case "twenty"
								intNumber = 20
							Case "twenty"
								intNumber = 20
							Case "thirty"
								intNumber = 30
							Case "forty"
								intNumber = 40
							Case "fifty"
								intNumber = 50
							Case "sixty"
								intNumber = 60
							Case "seventy"
								intNumber = 70
							Case "eighty"
								intNumber = 80
							Case "ninety"
								intNumber = 90
							Case "hundred"      'eg [x thousand] four hundred
								intMultiplier = 10
							Case "thousand"     'eg four thousand
								intMultiplier = 100
							Case Else
								Return -1
						End Select
					Case 2
						Select Case strParts(intCnt1)
							Case "one", "wan"
								intNumber = intNumber + 1 * intMultiplier
							Case "two", "to", "too"
								intNumber = intNumber + 2 * intMultiplier
							Case "three"
								intNumber = intNumber + 3 * intMultiplier
							Case "four", "for"
								intNumber = intNumber + 4 * intMultiplier
							Case "five"
								intNumber = intNumber + 5 * intMultiplier
							Case "six", "sex"
								intNumber = intNumber + 6 * intMultiplier
							Case "seven"
								intNumber = intNumber + 7 * intMultiplier
							Case "eight", "ate"
								intNumber = intNumber + 8 * intMultiplier
							Case "nine", "nan", "naan"
								intNumber = intNumber + 9 * intMultiplier
							Case "twenty"
								intNumber = intNumber + 20
							Case "thirty"
								intNumber = intNumber + 30
							Case "forty"
								intNumber = intNumber + 40
							Case "fifty"
								intNumber = intNumber + 50
							Case "sixty"
								intNumber = intNumber + 60
							Case "seventy"
								intNumber = intNumber + 70
							Case "eighty"
								intNumber = intNumber + 80
							Case "ninety"
								intNumber = intNumber + 90
							Case "hundred"      'eg [x thousand] four hundred and nine
								intMultiplier = 10
							Case "thousand"     'eg four thousand and nine
								intMultiplier = 100
							Case Else
								Return -1
						End Select
					Case 3, 4, 5, 6
						Select Case strParts(intCnt1)
							Case "one", "wan"
								intNumber = intNumber + 1 * intMultiplier
							Case "two", "to", "too"
								intNumber = intNumber + 2 * intMultiplier
							Case "three"
								intNumber = intNumber + 3 * intMultiplier
							Case "four", "for"
								intNumber = intNumber + 4 * intMultiplier
							Case "five"
								intNumber = intNumber + 5 * intMultiplier
							Case "six", "sex"
								intNumber = intNumber + 6 * intMultiplier
							Case "seven"
								intNumber = intNumber + 7 * intMultiplier
							Case "eight", "ate"
								intNumber = intNumber + 8 * intMultiplier
							Case "nine", "nan", "naan"
								intNumber = intNumber + 9 * intMultiplier
							Case "hundred"      'eg [x thousand] four hundred and twenty nine
								intMultiplier = 10
							Case "thousand"     'eg four thousand and twenty nine
								intMultiplier = 100
							Case Else
								Return -1
						End Select
					Case Else
						Return -1
				End Select
			End If
			intMultiplier = intMultiplier * 10
		End If
	Next
	If intPart = 0 Then	
		Return -1
	Else
		Return intNumber
    End If
	    
End Sub

Sub lib_DateFromDatetime(pdt As Long) As Long
	
	Return DateUtils.SetDate(DateTime.GetYear(pdt), DateTime.GetMonth(pdt), DateTime.GetDayOfMonth(pdt))
	
End Sub

Sub lib_DateFromNumber(pstrText As String) As Long

   	Dim dt As Long
	
	If IsNumber(pstrText) Then
		Try
			dt = pstrText
	        If DateTime.GetYear(dt) > 1949 And DateTime.GetYear(dt) < 2049 Then
				Return dt
			Else
				Return 0
			End If
	    Catch
	        Return 0
	    End Try
	Else
		Return 0
	End If
		
End Sub

'
' This version is designed to try to work out date(first) in text even if badly formatted like on receipts
' 20/10/20 - created
' 17/11/20 - now using DateFromText not IsDate due to compiler bug
' See lib_TimeFromRcpt for time
' Examples: right is another version of date on same receipt
'06-0CT-2020
'06-OCT-2020 10:28:39
'TIME 190CT20 11:36          Branch. Hastings Date: 19/10/2020
'IME O70CT20 12:34           Date 07/10/20 Time 12:34 Trt 10171447
'Branch fasting tate: 19/4   TIME 1900720 11:43
'19/10/2020 12:07 0#1984     GST No 11-019-852
'19/10/2020 11:15            190CT 11:15
'Date 10/10/20 Tine 14139    TIME 100ct20 14:36
'12/10/2020 14:08:57
'19/10/2020 ANS,             TIME 190CT 1
'March 9, 2021 11:16:09 0100194100
'
Sub lib_DateFromRcpt(pstrText As String) As Long

    Dim blnHaveNum                  As Boolean
	Dim blnJumpToNextTest			As Boolean
    Dim dt                          As Long
    Dim intCnt1                     As Int
    Dim intCnt2                     As Int
    Dim intCnt3                     As Int
    Dim intDaysInMonth              As Int
    Dim intYearNow                  As Int
    Dim strParts1()                 As String
    Dim strParts3(3)                As String
    Dim strMths()                   As String
    Dim Const ALLOWFUTUREDATE As Boolean = False

    strMths = Array As String("jan", "feb", "mar", "apr", "may", "jun", "jul", "aug", "sep", "oct", "nov", "dec")
	strParts1 = Regex.Split(" ", pstrText)
    intYearNow = DateTime.GetYear(DateTime.Now)
    
    ' Test1,2,3 look for whole date within one piece of the line
    For intCnt1 = 0 To strParts1.Length-1
		blnJumpToNextTest = False
'Test1:
        ' Vb recognises a date (assuming NZ format)
        dt = lib_DateFromText(strParts1(intCnt1))
        If DateTime.GetYear(dt) >= intYearNow - 2 And DateTime.GetYear(dt) <= intYearNow Then
            Return dt
        End If

'Test2:
        ' 06-0CT-2020->060CT2020->06|OCT|2020
		strParts1(intCnt1) = strParts1(intCnt1).Replace("-", "").Replace("/", "").Replace(" ", "").ToLowerCase 
		If strParts1(intCnt1).Length > 0 Then
	        If IsNumber(strParts1(intCnt1).SubString2(0, 1)) Then
				strParts1(intCnt1) = strParts1(intCnt1).Replace("ju1", "jul").Replace("0ct", "oct").Replace("n0v", "nov")
	            intCnt3 = 0
	            strParts3(intCnt3) = strParts1(intCnt1).SubString2(0, 1)
	            blnHaveNum = True
	            For intCnt2 = 1 To strParts1(intCnt1).Length-1
	                If blnHaveNum Then
	                    If IsNumber(strParts1(intCnt1).SubString2(intCnt2, intCnt2+1)) Then
	                        strParts3(intCnt3) = strParts3(intCnt3) & strParts1(intCnt1).SubString2(intCnt2, intCnt2+1)
	                    Else
	                        intCnt3 = intCnt3 + 1
	                        If intCnt3 > 2 Then
	                            blnJumpToNextTest = True
								Exit
	                        End If
	                        strParts3(intCnt3) = strParts1(intCnt1).SubString2(intCnt2, intCnt2+1)
	                        blnHaveNum = False
	                    End If
	                Else
	                    If Not(IsNumber(strParts1(intCnt1).SubString2(intCnt2, intCnt2+1))) Then
	                        strParts3(intCnt3) = strParts3(intCnt3) & strParts1(intCnt1).SubString2(intCnt2, intCnt2+1)
	                    Else
	                        intCnt3 = intCnt3 + 1
	                        If intCnt3 > 2 Then
	                            blnJumpToNextTest = True
								Exit
	                        End If
	                        strParts3(intCnt3) = strParts1(intCnt1).SubString2(intCnt2, intCnt2+1)
	                        blnHaveNum = True
	                    End If
	                End If
	            Next
				If Not(blnJumpToNextTest) Then
					If IsNumber(strParts3(0)) And Not(IsNumber(strParts3(1))) And IsNumber(strParts3(2)) Then
			            For intCnt2 = 0 To 11
			                If strParts3(1) = strMths(intCnt2) Then
			                    ' Valid month
								intDaysInMonth = DateUtils.NumberOfDaysInMonth(intCnt2 + 1, intYearNow)
			                    If strParts3(0) >= intYearNow - 2 And strParts3(0) <= intYearNow Then	'assuming must be 4 digit year else it could just be a day
			                        ' Year first (assume y/m/d)
			                        If strParts3(2) > 0 And strParts3(2) <= intDaysInMonth Then
										dt = DateUtils.SetDate(strParts3(0), intCnt2 + 1, strParts3(2))
			                            If dt <= lib_DateFromDatetime(DateTime.Now) Or ALLOWFUTUREDATE Then
			                                Return dt
			                            End If
			                        End If
			                    Else
									' Day first (assume d/m/y)
			                        If strParts3(0) > 0 And strParts3(0) <= intDaysInMonth Then
			                            If strParts3(2) >= intYearNow - 2 And strParts3(2) <= intYearNow Then
											dt = DateUtils.SetDate(strParts3(2), intCnt2 + 1, strParts3(0))
				                            If dt <= lib_DateFromDatetime(DateTime.Now) Or ALLOWFUTUREDATE Then
				                                Return dt
				                            End If
			                            else If strParts3(2) >= intYearNow - 2 - 2000 And strParts3(2) <= intYearNow - 2000 Then
											dt = DateUtils.SetDate(strParts3(2) + 2000, intCnt2 + 1, strParts3(0))
				                            If dt <= lib_DateFromDatetime(DateTime.Now) Or ALLOWFUTUREDATE Then
				                                Return dt
				                            End If
			                            End If
			                        End If
			                    End If
			                    Exit
			                End If
			            Next
					End If
				End If
	        End If
		End If

'Test3:
    Next
    
'Test4:
    ' Test 4 looks for date with spaces in it on line  eg. '26 oct 20'   assuming day month year
    For intCnt1 = 0 To strParts1.Length-1
        For intCnt2 = 0 To 11
            If strParts1(intCnt1) = strMths(intCnt2) Then
                ' Valid month
                If intCnt1 > 0 And intCnt1 < strParts1.Length-1 Then
                    If IsNumber(strParts1(intCnt1 - 1)) And IsNumber(strParts1(intCnt1 + 1)) Then
						intDaysInMonth = DateUtils.NumberOfDaysInMonth(intCnt2 + 1, intYearNow)
                        If strParts1(intCnt1 - 1) > 0 And strParts1(intCnt1 - 1) <= intDaysInMonth Then
                            If (strParts1(intCnt1 + 1) >= intYearNow - 2 And strParts1(intCnt1 + 1) <= intYearNow) Or (strParts1(intCnt1 + 1) >= intYearNow - 2 - 2000 And strParts1(intCnt1 + 1) <= intYearNow - 2000) Then
								dt = DateUtils.SetDate(strParts1(intCnt1 + 1), intCnt2 + 1, strParts1(intCnt1 - 1))
	                            If dt <= lib_DateFromDatetime(DateTime.Now) Or ALLOWFUTUREDATE Then
	                                Return dt
	                            End If
                            End If
                        End If
                    End If
                End If
                Exit
            End If
        Next
    Next
	
'Test5
	' Look for date in this type of text: March 9, 2021 11:16:09 0100194100
	intCnt1 = pstrText.IndexOf(":") - 3
	If intCnt1 > 5 And strParts1.Length >= 2 Then
        For intCnt2 = 0 To 11
            If strParts1(0).SubString2(0, strMths(intCnt2).Length) = strMths(intCnt2) Then
				strParts1(1) = strParts1(1).Replace(",", "")
				If IsNumber(strParts1(1)) Then
					If IsNumber(strParts1(2)) Then
						intDaysInMonth = DateUtils.NumberOfDaysInMonth(intCnt2 + 1, intYearNow)
                        If strParts1(1) > 0 And strParts1(1) <= intDaysInMonth Then
							dt = DateUtils.SetDate(strParts1(2), intCnt2 + 1, strParts1(1))
                            If dt <= lib_DateFromDatetime(DateTime.Now) Or ALLOWFUTUREDATE Then
                                Return dt
                            End If
						End If
					End If
				End If
	        End If
		Next
	End If
	
	Return 0
    
End Sub

Sub lib_DateFromText(pstrText As String) As Long

   Dim strText As String
   Dim dt As Long

   strText = pstrText.Replace(".", "/")
   strText = strText.Replace("-", "/")
    
	Try
        dt = DateTime.DateParse(strText)
        Return dt
    Catch
        Return 0
    End Try
		
End Sub

Sub lib_DropText(pstrFromText As String, pstrDropText As String, pblnRepeatCheck As Boolean, pblnFromBeginning As Boolean) As String

	Dim strDropText As String = pstrDropText.ToLowerCase
	Dim strFromText As String = pstrFromText.Trim
    
    If pblnFromBeginning Then
        Do While strFromText.ToLowerCase.StartsWith(strDropText)
            strFromText = strFromText.SubString(pstrDropText.Length) 
            If Not(pblnRepeatCheck) Then
                Exit
            End If
        Loop
    Else
        Do While strFromText.ToLowerCase.EndsWith(strDropText)
            strFromText = strFromText.SubString2(0, strFromText.Length - pstrDropText.Length) 
            If Not(pblnRepeatCheck) Then
                Exit
            End If
        Loop
    End If
    Return strFromText
    
End Sub

Sub lib_FormatTimeHHMMSS(pintHours As Int, pintMins As Int, pintSecs As Int, pblnDontShowZeroHours As Boolean, pblnDontShowZeroMins As Boolean) As String
	
	Dim strText As String

	If pintHours > 0 Or Not(pblnDontShowZeroHours) Then
		If pintHours < 10 Then
			strText = strText & "0"
		End If
		strText = strText & pintHours & ":"
		If pintMins < 10 Then
			strText = strText & "0"
		End If
		strText = strText & pintMins & ":"
	Else
		If pintMins > 0 Or Not(pblnDontShowZeroMins) Then
			' Will not have leading 0
			strText = strText & pintMins & ":"
		End If
	End If
	If pintSecs < 10 Then
		strText = strText & "0"
	End If
	strText = strText & pintSecs
	Return strText
	
End Sub
'
' Don't think have ever used this. In theory returns int array containing R,G,B
'
Sub lib_GetRGBFromColorInt(Color As Int) As Int()

	Private res(4) As Int
	res(0) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff0000), 16)
	res(1) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff00), 8)
	res(2) = Bit.And(Color, 0xff)
	'res(3) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff000000), 24)	'alpha
	Return res
	
End Sub

Sub lib_GetColorHexFromInt(clr As Int) As String
    Dim bc As ByteConverter
    Return bc.HexFromBytes(bc.IntsToBytes(Array As Int(clr)))
End Sub

Sub lib_GetColorIntFromHex(Hex As String) As Int
    Dim bc As ByteConverter
    If Hex.StartsWith("#") Then 
        Hex = Hex.SubString(1)
    Else If Hex.StartsWith("0x") Then 
        Hex = Hex.SubString(2)
    End If
    Dim ints() As Int = bc.IntsFromBytes(bc.HexToBytes(Hex))
    Return ints(0)
End Sub
'
' Can use result to apply to a Color property
' If want to assign to a control in the Designer, put result through lib_DecimalToHex() and use that.
'
Sub lib_GetColorIntFromRGB(R As Int, G As Int,B As Int) As Int
	
	Dim l As Label
	l.Initialize("") 
	l.TextColor = Colors.RGB(R,G,B)
	Return l.TextColor
	
End Sub

Sub lib_DateSuffix(pdt As Long) As String
	
	Dim intDay As Int = DateTime.GetDayOfMonth(pdt)
	
	Select Case intDay
		Case 1
			Return "st"
		Case 2
			Return "nd"
		Case 3
			Return "rd"
		Case Else
			Return "th"
	End Select
	
End Sub
'
' Both vars likely to contain date & time (but only pdtD date & pdtT time will be used)
' May have come from DateDialog.DateTicks and TimeDialog.TimeTicks
'
Sub lib_DateTimeFromDateAndTime(pdtD As Long, pdtT As Long) As Long
	
	Dim p As Period

	p.Years = DateTime.GetYear(pdtD)
	p.Months = DateTime.GetMonth(pdtD)
	p.Days = DateTime.GetDayOfMonth(pdtD)
	p.Hours = DateTime.GetHour(pdtT)
	p.Minutes = DateTime.GetMinute(pdtT)
	p.Seconds = DateTime.GetSecond(pdtT)
	Return DateUtils.SetDateAndTime(p.Years, p.Months, p.Days, p.Hours, p.Minutes, p.Seconds)

End Sub
'
' If swapping hex/dec & back again eg. working with TextColour property (rtns int) and comparing to hex as shows in designer (RGB values come from hex)
' then that the int may be -ve which means the 1st two hex digits show FF. I think this may be used as alpha (transparency) though it wouldn't handle part trans.
' Either way, if it stays neg it changes the whole hex value, not just the first two chars. So we Abs() it to fix that. If you want alpha, handle separately.
'
Sub lib_DecimalToHex(pint As Int) As String

	Return Bit.ToHexString(Abs(pint)).ToUpperCase 

End Sub

Sub lib_HexToDecimal(pstrHex As String) As Int

	Return Bit.ParseInt(pstrHex, 16)

End Sub
'
' Move the item at pFromIndex to pToIndex in the list pList
' Note: If pFromIndex does not point to a valid item in pList, then -1 is returned.
' If the item is successfully moved, return the index of its new location.
'
Sub lib_ListMoveItem(pList As List, pFromIndex As Int, pToIndex As Int) As Int
	
	Private Result As Int=-1
	
	If pList.IsInitialized Then
		If pFromIndex >= 0 And pFromIndex < pList.Size Then				'We can't do anything if pFromIndex does not point to an entry in pList
			pToIndex = Max(0,Min(pToIndex, pList.Size))					'Make sure pToIndex falls within range of pList
			If pFromIndex = pToIndex Then								'We don't need to move an entry to itself
				Result = pFromIndex										'  so just return the existing index.
			Else
				Private locObject As Object
				locObject = pList.Get(pFromIndex)						'Get the item to move at pFromIndex
				pList.InsertAt(pToIndex, locObject)						'  and insert it at pToIndex.
				If pToIndex < pFromIndex Then							'Inserting the item below the pFromIndex will shift the pFromIndex up 1 position
					pFromIndex = pFromIndex + 1							'  so we need to compensate for the shift in order to delete the correct "From" item.
				Else
					pToIndex   = pToIndex - 1							'Inserting the item above aFrom index means we need to correct pToIndex to compensate for removing pFromIndex before we return pToIndex
				End If
				pList.RemoveAt(pFromIndex)								'Remove the old "From" entry
				Result = pToIndex										'pToIndex is the position of new entry to be returned
			End If
		End If
	End If
	Return Result														'Return the index of the new position
	
End Sub
'
' Swap the items at pIndex1 & aToIndex2 in the list pList
' Note: If pIndex1 or pIndex2 do not point to a valid items in pList, then -1 is returned.
' If the items swapped successfully, return True otherwise return False.
'
Sub lib_ListSwapItems(pList As List, pIndex1 As Int, pIndex2 As Int) As Boolean
	
	Private Result As Boolean=False
	
	If pList.IsInitialized Then
		' Check pIndex1 & pIndex2 point to an entry in pList
		If pIndex1 <> pIndex2 And pIndex1 >= 0 And pIndex1 < pList.Size And pIndex2 >= 0 And pIndex2 < pList.Size Then
			Private locObject2 As Object
			locObject2 = pList.Get(pIndex2)
			pList.Set(pIndex2, pList.Get(pIndex1))
			pList.Set(pIndex1, locObject2)
			Result = True
		End If
	End If
	Return Result	
																												'Return the index of the new position
End Sub
'
' Turn list of x=y's into a map
'
Sub lib_ListToMap(pstrSplitChar As String, plst As List) As Map
	
	Dim intCnt1 As Int
	Dim intCnt2 As Int
	Dim strLine As String
	Dim m As Map
	
	m.Initialize
	For intCnt1 = 0 To plst.Size-1
		strLine = plst.Get(intCnt1)
		intCnt2 = strLine.IndexOf(pstrSplitChar)
		If intCnt2 > -1 Then
			m.Put(strLine.SubString2(0, intCnt2), strLine.SubString(intCnt2+1))
		End If
	Next
	Return m
	
End Sub

Sub lib_NullToZero(pstrValue As String, pstrRtnIfNull As String) As String

	If pstrValue = "null" Or pstrValue = "" Then
		Return pstrRtnIfNull
	Else
		Return pstrValue
	End If

End Sub

Sub lib_PadLeft(pstrText As String, pintMinChars As Int, pstrPadChar As String) As String
	
	Dim intCnt1 As Int
	Dim strPaddedText As String
	
	For intCnt1 = 1 To pintMinChars - pstrText.Length
		strPaddedText = strPaddedText & pstrPadChar
	Next
	Return strPaddedText & pstrText
	
End Sub

Sub lib_Plural(pintCnt As Int) As String
	
	If pintCnt <> 1 Then
		Return "s"
	Else
		Return ""
	End If
	
End Sub
'
' Replace chars in text which are not valid as part of a file name
' Typical pstrReplaceWith is -
'
Sub lib_ReplInvalidChars_Filename(pstrName As String, pstrReplaceWith As String) As String

    Dim intCnt1                         As Int
    Dim strChar                         As String
    Dim strNewName                      As String

    For intCnt1 = 0 To pstrName.Length-1
        strChar = pstrName.SubString2(intCnt1,  intCnt1+1)
        If LibGen.lib_IsValidChar_Filename(strChar) Then
            strNewName = strNewName & strChar
        Else
            strNewName = strNewName & pstrReplaceWith
        End If
    Next

    Return strNewName
    
End Sub
'
' Lke Regex.Split but can split on multiple chars
' If want to turn list of x=y's into a map, call lib_ListToMap() - it will dump any lines that don't have reqd splitchar
'
Sub lib_SplitMultiChars(pstrSplitChars As String, pstrText As String) As List
	
	Dim lstRtn As List
	Dim blnExit As Boolean
	Dim intCnt1 As Int
	Dim intCnt2 As Int
	Dim strText As String = pstrText
	
	lstRtn.Initialize
	Do While strText <> "" Then
		For intCnt1 = 0 To strText.Length - 1
			blnExit = False
			For intCnt2 = 0 To pstrSplitChars.Length - 1
				'Log(intCnt1 & "," & intCnt2 & "," & strText.SubString2(intCnt1, intCnt1+1) & "," & pstrSplitChars.SubString2(intCnt2, intCnt2+1))
				If strText.SubString2(intCnt1, intCnt1+1) = pstrSplitChars.SubString2(intCnt2, intCnt2+1) Then
					If intCnt1 > 0 Then
						lstRtn.Add(strText.SubString2(0, intCnt1))
					End If
					If intCnt1 < strText.Length Then
						strText = strText.SubString(intCnt1 + 1)
					End If
					blnExit = True
					Exit
				End If
			Next
			If blnExit Then
				Exit
			End If
		Next
	Loop
	Return lstRtn
	
End Sub
'
' Equiv to String vb function
'
Sub lib_String(pintStringlen As Int, pstrChar As String) As String
	
	Dim intCnt1 As Int
	Dim strResult As String
	
	For intCnt1 = 1 To pintStringlen
		strResult = strResult & pstrChar
	Next
	Return strResult
	
End Sub
'
' A contact may have emojis or underscore to affect look/positioning
' Strip these out
'
Sub lib_StripInvalidCharsFromPersonsName(pstrName As String) As String

	Dim intCnt1 As Int 
	Dim strRtnName As String
	Dim const VALIDCHARS As String = "abcdefghijklmnopqrstuvwxyz0123456789"
	
	For intCnt1 = 0 To pstrName.Length-1
		If VALIDCHARS.IndexOf(pstrName.ToLowerCase.CharAt(intCnt1)) >=0 Then
			strRtnName = strRtnName & pstrName.CharAt(intCnt1)	
		End If
	Next
	Return strRtnName
	
End Sub

Sub lib_TimeFromDatetime(pdt As Long) As Long
	
	' can't just get time. try lib_DateTimeFromDateAndTime
	
End Sub
